<?xml version="1.0" encoding="UTF-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<!-- author: lee_yongwoo@waregram.com -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="text" encoding="utf-8" indent="yes"/>



<xsl:template name ="template_information" >
  <xsl:variable name="in_data_domain_namespace">
    <xsl:call-template name="get_data_domain_namespace_dot">
      <xsl:with-param name="data_domain_id" select="in_data_domain_id" />
    </xsl:call-template>
  </xsl:variable>
  <xsl:variable name="out_data_domain_namespace">
    <xsl:call-template name="get_data_domain_namespace_dot">
      <xsl:with-param name="data_domain_id" select="out_data_domain_id" />
    </xsl:call-template>
  </xsl:variable>
// proxy
public interface IProxy_method_<xsl:value-of select="name"/>
{
    void on_link(UInt32 _msg_num, Int32 _err, Double _elapsed);
    void on_unlink(Int32 _err);
    void on_sync(Sync_model _sync_model, Double _elapsed, Double _limit<xsl:if test="out_data!='(null)'">, ref Nerv36.Data<xsl:value-of select="$out_data_domain_namespace"/>.<xsl:value-of select="out_data"/> _inf_dat_</xsl:if>);
}
public unsafe class Proxy_method_<xsl:value-of select="name"/>
{
    static Nerv36.Proxy_information.on_link_ft on_link_ = new Nerv36.Proxy_information.on_link_ft(on_link);
    static Nerv36.Proxy_information.on_unlink_ft on_unlink_ = new Nerv36.Proxy_information.on_unlink_ft(on_unlink);
    static Nerv36.Proxy_information.on_sync_ft on_sync_     = new Nerv36.Proxy_information.on_sync_ft(on_sync);

    static ConcurrentDictionary&lt;IntPtr, Proxy_method_<xsl:value-of select="name"/>&gt; dict = new ConcurrentDictionary&lt;IntPtr, Proxy_method_<xsl:value-of select="name"/>&gt;();

    public static void on_link(IntPtr _information_, UInt32 _msg_num, Int32 _err, Double _elapsed)
    {
        dict[_information_].iinformation.on_link(_msg_num, _err, _elapsed);
    }

    public static void on_unlink(IntPtr _information_, Int32 _err)
    {
        dict[_information_].iinformation.on_unlink(_err);
    }

    public static void on_sync(IntPtr _information_, Sync_model _sync_model, Double _elapsed, Double _limit, IntPtr _inf_dat_, UInt32 _inf_size)
    {<xsl:if test="out_data!='(null)'">
        Nerv36.Data<xsl:value-of select="$out_data_domain_namespace"/>.<xsl:value-of select="out_data"/>* inf_data_ = (Nerv36.Data<xsl:value-of select="$out_data_domain_namespace"/>.<xsl:value-of select="out_data"/>*)_inf_dat_;
        </xsl:if>
        dict[_information_].iinformation.on_sync(_sync_model, _elapsed, _limit<xsl:if test="out_data!='(null)'">, ref *inf_data_</xsl:if>);
    }


    public IntPtr information_;
    public IProxy_method_<xsl:value-of select="name"/> iinformation;

    public Proxy_method_<xsl:value-of select="name"/>(ref Nerv36.Proxy _object_, IProxy_method_<xsl:value-of select="name"/> _iinformation)
    {
        information_ = Nerv36.Proxy_information.alloc(<xsl:value-of select="code"/>, _object_.object_,on_link_,on_unlink_,on_sync_);
        dict[information_] = this;
        iinformation = _iinformation;
    }
    ~Proxy_method_<xsl:value-of select="name"/>()
    {
        // Nerv36.Proxy_information.free(information_);
        // API.nerv_finalize()에서 정리되지 않은 객체를 자동해제하므로
        // C#에서는 Nerv36.Proxy_information.free(information_); 로 정리하지 않는다.
        // C#의 소멸자는 언제 호출될지 알수 없다.

        Proxy_method_<xsl:value-of select="name"/> information_reference;
        dict.TryRemove(information_, out information_reference);
    }

    public Boolean is_linked()
    {
        Boolean b = Nerv36.Proxy_information.is_linked(information_);
        return b;
    }

    public Int32 delegate_link(ref UInt32 _msg_num_, Boolean _reliability, Double _limit)
    {
        Int32 err = Nerv36.Proxy_information.delegate_link( information_, ref _msg_num_, _reliability, _limit);
        return err;
    }

    public IntPtr async_link(Boolean _reliability, Double _limit)
    {
        IntPtr promise_ = Nerv36.Proxy_information.async_link(information_, _reliability, _limit);
        return promise_;
    }

    public Int32 await_link_return(IntPtr _promise_, ref Double _elapsed_)
    {
        Int32 err = Nerv36.Proxy_information.await_link_return(information_, _promise_, ref _elapsed_);
        return err;
    }

    public Int32 link(Boolean _reliability, Double _limit, ref Double _elapsed_)
    {
        IntPtr promise_ = Nerv36.Proxy_information.async_link( information_, _reliability, _limit);
        Int32 err = Nerv36.Proxy_information.await_link_return(information_, promise_, ref _elapsed_);
        return err;
    }

    public void unlink()
    {
        Nerv36.Proxy_information.unlink(information_);
    }

    public void set_sync(Boolean _use_on_sync)
    {
        Nerv36.Proxy_information.set_sync(information_, _use_on_sync);
    }

    public IntPtr see_history(UIntPtr _size)
    {
        IntPtr letter_ = Nerv36.Proxy_information.see_history(information_, _size);
        return letter_;
    }

    public void set_history_size(UIntPtr _history_size)
    {
        Nerv36.Proxy_information.set_history_size(information_, _history_size);
    }

  <xsl:if test="out_data!='(null)'">
    public Int32 read(ref Nerv36.Data<xsl:value-of select="$out_data_domain_namespace"/>.<xsl:value-of select="out_data"/> _inf_dat_)
    {
        UInt32 inf_size = (UInt32)_inf_dat_.sizeofall();

        fixed ( Nerv36.Data<xsl:value-of select="$out_data_domain_namespace"/>.<xsl:value-of select="out_data"/>* inf_data_ = &amp;_inf_dat_)
        {
            Int32 err = Nerv36.Proxy_information.read(information_, (IntPtr)inf_data_, ref inf_size);
            return err;
        }
    }
  </xsl:if>
}

// stub
public interface IStub_method_<xsl:value-of select="name"/>
{
    Int32 on_link(Address _proxy_addr, Boolean _reliability, Double _elapsed, Double _limit);
    void on_unlink(Address _proxy_addr, Int32 _err);
}

public unsafe class Stub_method_<xsl:value-of select="name"/>
{
    static Nerv36.Stub_information.on_link_ft on_link_     = new Nerv36.Stub_information.on_link_ft(on_link);
    static Nerv36.Stub_information.on_unlink_ft on_unlink_ = new Nerv36.Stub_information.on_unlink_ft(on_unlink);
    static ConcurrentDictionary&lt;IntPtr, Stub_method_<xsl:value-of select="name"/>&gt; dict = new ConcurrentDictionary&lt;IntPtr, Stub_method_<xsl:value-of select="name"/>&gt;();

    // nerv_stub_information delegate
    public static Int32 on_link(IntPtr _information_, Address _proxy_addr, Boolean _reliability, Double _elapsed, Double _limit)
    {
        Int32 err = dict[_information_].iinformation.on_link(_proxy_addr, _reliability, _elapsed, _limit);
        return err;
    }
    public static void on_unlink(IntPtr _information_, Address _proxy_addr, Int32 _err)
    {
        dict[_information_].iinformation.on_unlink(_proxy_addr, _err);
    }

    public IntPtr information_;
    public IStub_method_<xsl:value-of select="name"/> iinformation;

    public Stub_method_<xsl:value-of select="name"/>(ref Nerv36.Stub _object_, IStub_method_<xsl:value-of select="name"/> _iinformation)
    {
        information_ = Nerv36.Stub_information.alloc(<xsl:value-of select="code"/>, _object_.object_, on_link_, on_unlink_);
        dict[information_] = this;
        iinformation = _iinformation;
    }
    ~Stub_method_<xsl:value-of select="name"/>()
    {
        // Nerv36.Stub_information.free(information_);
        // API.nerv_finalize()에서 정리되지 않은 객체를 자동해제하므로
        // C#에서는 Nerv36.Stub_information.free(information_); 로 정리하지 않는다.
        // C#의 소멸자는 언제 호출될지 알수 없다.

        Stub_method_<xsl:value-of select="name"/> information_reference;
        dict.TryRemove(information_, out information_reference);
    }

    public void unlink(Address _proxy_addr)
    {
        Nerv36.Stub_information.unlink(information_, _proxy_addr);
    }

    public void unlink_all_proxy()
    {
        Nerv36.Stub_information.unlink_all_proxy(information_);
    }

  <xsl:if test="out_data!='(null)'">
    public ref Nerv36.Data<xsl:value-of select="$out_data_domain_namespace"/>.<xsl:value-of select="out_data"/> get()
    {
        IntPtr inf_data_ = Nerv36.Stub_information.get(information_, Nerv36.Data<xsl:value-of select="$out_data_domain_namespace"/>.<xsl:value-of select="out_data"/>._sizeof);
        return ref *(Nerv36.Data<xsl:value-of select="$out_data_domain_namespace"/>.<xsl:value-of select="out_data"/>*)inf_data_;
    }

    public void cancel()
    {
        Nerv36.Stub_information.cancel(information_);
    }

    public Int32 post(ref Nerv36.Data<xsl:value-of select="$out_data_domain_namespace"/>.<xsl:value-of select="out_data"/> _inf_dat_ )
    {
        // 데이터를 post함수를 통해서 전달하지는 않고, 다만 크기만 지정한다
        // post 데이터 메모리는 get 으로 획득한 공간이다.
        Int32 err = Nerv36.Stub_information.post(information_, _inf_dat_.fit_size() );
        return err;
    }

    public Int32 write(ref Nerv36.Data<xsl:value-of select="$out_data_domain_namespace"/>.<xsl:value-of select="out_data"/> _inf_dat_)
    {
        fixed (Nerv36.Data<xsl:value-of select="$out_data_domain_namespace"/>.<xsl:value-of select="out_data"/>* inf_data_ = &amp;_inf_dat_)
        {
            Int32 err = Nerv36.Stub_information.write(information_, (IntPtr)inf_data_, _inf_dat_.fit_size() );
            return err;
        }
    }

    public Int32 read(ref Nerv36.Data<xsl:value-of select="$out_data_domain_namespace"/>.<xsl:value-of select="out_data"/> _inf_dat_)
    {
        UInt32 inf_size = (UInt32)_inf_dat_.sizeofall();

        fixed ( Nerv36.Data<xsl:value-of select="$out_data_domain_namespace"/>.<xsl:value-of select="out_data"/>* inf_data_ = &amp;_inf_dat_)
        {
            Int32 err = Nerv36.Proxy_information.read(information_, (IntPtr)inf_data_, ref inf_size);
            return err;
        }
    }
  </xsl:if>
  <xsl:if test="out_data='(null)'">

    public Int32 write()
    {
        Int32 err = Nerv36.Stub_information.write(information_, IntPtr.Zero, 0 );
        return err;
    }
  </xsl:if>

    public IntPtr see_history(UIntPtr _size)
    {
        IntPtr letter_ = Nerv36.Stub_information.see_history(information_, _size);
        return letter_;
    }

    public void set_history_size(UIntPtr _history_size)
    {
        Nerv36.Stub_information.set_history_size(information_, _history_size);
    }
}
</xsl:template>



</xsl:stylesheet>
