<?xml version="1.0" encoding="utf-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:include href="../../../xsl_util.xsl"/>

<xsl:output method="text" encoding="utf-8" indent="yes"/>

<xsl:param name = "export_stub_class_id" />

<xsl:template match="/">
  <xsl:for-each select="/nerv_icde/component/stub_list/row[id=$export_stub_class_id]">
    <xsl:variable name="method_domain_id" select="method_domain_id" />
    <xsl:variable name="interface_name" select="interface_name" />
    <xsl:variable name="class_name" select="class_name" />

    <xsl:variable name="method_domain_path">
      <xsl:call-template name="get_method_domain_path">
        <xsl:with-param name="mathod_domain_id" select="$method_domain_id" />
      </xsl:call-template>
    </xsl:variable>

    <xsl:variable name="method_domain_namespace">
      <xsl:call-template name="replace">
        <xsl:with-param name="text" select="$method_domain_path" />
        <xsl:with-param name="replace" select="'/'" />
        <xsl:with-param name="by" select="'.'" />
      </xsl:call-template>
    </xsl:variable>

/*******************************************************************************
Document Header
component_name : <xsl:value-of select="../../name"/>
component_id : <xsl:value-of select="component_id"/>
method_domain_id : <xsl:value-of select="method_domain_id"/>
method_domain_name : Nerv36.Method<xsl:value-of select="$method_domain_namespace"/>
interface_name : Nerv36.Method<xsl:value-of select="$method_domain_namespace"/>.IStub_<xsl:value-of select="interface_name"/>
class_name : <xsl:value-of select="class_name"/>
*******************************************************************************/
<!-- using System;
using System.Collections.Generic;
using System.Collections.Concurrent; -->
using System;
using System.Collections.Generic;
using System.Collections.Concurrent;
using System.Threading.Tasks;

using Nerv36;
using Nerv36.Method<xsl:value-of select="$method_domain_namespace"/>;<xsl:text/>
    <xsl:for-each select="/nerv_icde/methoddomain/row">
      <xsl:if test="id=$method_domain_id">
        <xsl:for-each select="ref_data_domain/row">
          <xsl:variable name="data_domain_namespace">
            <xsl:call-template name="get_data_domain_namespace_dot">
              <xsl:with-param name="data_domain_id" select="data_domain_id" />
            </xsl:call-template>
          </xsl:variable>
using Nerv36.Data<xsl:value-of select="$data_domain_namespace"/>;
        </xsl:for-each>
      </xsl:if>
    </xsl:for-each>
    <!-- <xsl:for-each select="/nerv_icde/methoddomain/row[id=$method_domain_id]">
      <xsl:for-each select="interface/row[name=$interface_name]">
        <xsl:for-each select="membermethod/row">
          <xsl:variable name="method_name" select="method_name" />
          <xsl:for-each select="../../../../method/row[name=$method_name]">
            <xsl:variable name="in_data_domain_namespace">
              <xsl:call-template name="get_data_domain_namespace_dot">
                <xsl:with-param name="data_domain_id" select="in_data_domain_id" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="out_data_domain_namespace">
              <xsl:call-template name="get_data_domain_namespace_dot">
                <xsl:with-param name="data_domain_id" select="out_data_domain_id" />
              </xsl:call-template>
            </xsl:variable>
          <xsl:if test="in_data != '(null)'"><xsl:text>
</xsl:text>using Nerv36.Data.<xsl:value-of select="substring($in_data_domain_namespace,2)"/>;</xsl:if>
          <xsl:if test="out_data != '(null)'"><xsl:text>
</xsl:text>using Nerv36.Data.<xsl:value-of select="substring($out_data_domain_namespace,2)"/>;</xsl:if>
          </xsl:for-each>
        </xsl:for-each>
      </xsl:for-each>
    </xsl:for-each> -->
public class <xsl:value-of select="$class_name"/>
    : Stub_<xsl:value-of select="$interface_name"/>
    , IStub_<xsl:value-of select="$interface_name"/>
{
    public Address proxy_addr;

    public <xsl:value-of select="$class_name"/>() { alloc(this); }

    void IStub.on_connect(Address _proxy_addr)
    {
        Output.Log(string.Format(
            "<xsl:value-of select="$class_name"/>.IStub.on_connect("+
            "{2}[_proxy_addr.ip={0}, _proxy_addr.port={1:D}])",
            Util.inet_ntoa(_proxy_addr.ip), _proxy_addr.port, _proxy_addr.id));
            proxy_addr = _proxy_addr;
    }
    void IStub.on_disconnect(Address _proxy_addr)
    {
        Output.Log(string.Format(
            "<xsl:value-of select="$class_name"/>.IStub.on_disconnect("+
            "{2}[_proxy_addr.ip={0}, _proxy_addr.port={1:D}])",
            Util.inet_ntoa(_proxy_addr.ip), _proxy_addr.port, _proxy_addr.id));
            proxy_addr = _proxy_addr;
    }

    <xsl:for-each select="/nerv_icde/methoddomain/row[id=$method_domain_id]">
      <xsl:for-each select="interface/row[name=$interface_name]">
        <xsl:for-each select="membermethod/row">
          <xsl:variable name="method_name" select="method_name" />
          <xsl:for-each select="../../../../method/row[name=$method_name]">
            <xsl:variable name="in_data_domain_namespace">
              <xsl:call-template name="get_data_domain_namespace_dot">
                <xsl:with-param name="data_domain_id" select="in_data_domain_id" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="out_data_domain_namespace">
              <xsl:call-template name="get_data_domain_namespace_dot">
                <xsl:with-param name="data_domain_id" select="out_data_domain_id" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:if test="type!='BROADCAST'" >
    /***************************************************************************
    Method: <xsl:value-of select="name"/>
    Input: <xsl:if test="in_data != '(null)'">Nerv36.Data.<xsl:value-of select="substring($in_data_domain_namespace,2)"/>.<xsl:value-of select="in_data"/></xsl:if>
    output: <xsl:if test="out_data != '(null)'">Nerv36.Data.<xsl:value-of select="substring($out_data_domain_namespace,2)"/>.<xsl:value-of select="out_data"/></xsl:if>
    Method Type: <xsl:value-of select="type"/>
    Code: <xsl:value-of select="code"/>
    Description: <xsl:value-of select="description"/>
    ***************************************************************************/<xsl:text/>
            </xsl:if>


            <xsl:choose>
              <xsl:when test="type='CALL'">
    Int32 IStub_method_<xsl:value-of select="$method_name"/>.on_call(
        Address _proxy_addr,
        <xsl:if test="in_data!='(null)'">ref Nerv36.Data.<xsl:value-of select="substring($in_data_domain_namespace,2)"/>.<xsl:value-of select="in_data"/> _call_data_,</xsl:if>
        <xsl:if test="out_data!='(null)'">ref Nerv36.Data.<xsl:value-of select="substring($out_data_domain_namespace,2)"/>.<xsl:value-of select="out_data"/> _return_data_,</xsl:if>
        Double _elapsed,
        Double _limit)
    {
        Output.Log(string.Format(
            "<xsl:value-of select="$class_name"/>."+
            "IStub_method_<xsl:value-of select="$method_name"/>.on_call("+
            " {4}[_proxy_addr.ip={0}, _proxy_addr.port={1:D}],"+
            " _elapsed={2:F}), _limit={3:F})",
            Util.inet_ntoa(_proxy_addr.ip), _proxy_addr.port,
            _elapsed, _limit, _proxy_addr.id));
        <xsl:if test="in_data!='(null)'">_call_data_.print("<xsl:value-of select="in_data"/>");</xsl:if>
        <xsl:if test="out_data!='(null)'">_return_data_.set(0);</xsl:if>
        return 0;
    }<xsl:text/>

    void IStub_method_<xsl:value-of select="$method_name"/>.on_cancel(Address _proxy_addr, Int32 _err)
    {
        Output.Log(string.Format(
            "<xsl:value-of select="$class_name"/>."+
            "IStub_method_<xsl:value-of select="$method_name"/>.on_cancel("+
            " {3}[_proxy_addr.ip={0}, _proxy_addr.port={1:D}], _err={2:D})",
            Util.inet_ntoa(_proxy_addr.ip), _proxy_addr.port, _err, _proxy_addr.id));
    }<xsl:text/>
              </xsl:when>



              <xsl:when test="type='CALLBACK'">
                <xsl:choose >
                  <xsl:when test="in_data='(null)'">
    void IStub_method_<xsl:value-of select="$method_name"/>.on_return(
        UInt32 _msg_num,
        Address _proxy_addr,
        Int32 _err,
        Double _elapsed)
    {
        Output.Log(string.Format(
            "<xsl:value-of select="$class_name"/>."+
            "IStub_method_<xsl:value-of select="$method_name"/>.on_return("+
            " {3}[_proxy_addr.ip={0}, _proxy_addr.port={1:D}], _elapsed={2:F})",
            Util.inet_ntoa(_proxy_addr.ip), _proxy_addr.port, _elapsed, _proxy_addr.id));
    }<xsl:text/>
                  </xsl:when>
                  <xsl:otherwise>
    void IStub_method_<xsl:value-of select="$method_name"/>.on_return(
        UInt32 _msg_num,
        Address _proxy_addr,
        Int32 _err,
        ref Nerv36.Data.<xsl:value-of select="substring($in_data_domain_namespace,2)"/>.<xsl:value-of select="in_data"/> _ret_dat_,
        Double _elapsed)
    {
        Output.Log(string.Format(
            "<xsl:value-of select="$class_name"/>."+
            "IStub_method_<xsl:value-of select="$method_name"/>.on_return("+
            " {3}[_proxy_addr.ip={0}, _proxy_addr.port={1:D}], _elapsed={2:F})",
            Util.inet_ntoa(_proxy_addr.ip), _proxy_addr.port, _elapsed, _proxy_addr.id));
        if(_err==0) _ret_dat_.print("<xsl:value-of select="in_data"/>");
    }<xsl:text/>
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:when>




              <xsl:when test="type='SIGNAL'">
    void IStub_method_<xsl:value-of select="$method_name"/>.on_signal(
        Address _proxy_addr,
        <xsl:if test="in_data!='(null)'">ref Nerv36.Data.<xsl:value-of select="substring($in_data_domain_namespace,2)"/>.<xsl:value-of select="in_data"/> _signal_data_,</xsl:if>
        Double _elapsed)
    {
        Output.Log(string.Format(
            "<xsl:value-of select="$class_name"/>."+
            "IStub_method_<xsl:value-of select="$method_name"/>.on_signal("+
            " {3}[_proxy_addr.ip={0}, _proxy_addr.port={1:D}], _elapsed={2:F}))",
            Util.inet_ntoa(_proxy_addr.ip), _proxy_addr.port, _elapsed, _proxy_addr.id));
        <xsl:if test="in_data!='(null)'">_signal_data_.print("<xsl:value-of select="in_data"/>");</xsl:if>
    }<xsl:text/>

    void IStub_method_<xsl:value-of select="$method_name"/>.on_cancel( Address _proxy_addr, Int32 _err)
    {
        Output.Log(string.Format(
            "<xsl:value-of select="$class_name"/>."+
            "IStub_method_<xsl:value-of select="$method_name"/>.on_cancel("+
            " {3}[_proxy_addr.ip={0}, _proxy_addr.port={1:D}], _err={2:D})",
            Util.inet_ntoa(_proxy_addr.ip), _proxy_addr.port, _err, _proxy_addr.id));
    }<xsl:text/>
              </xsl:when>



              <xsl:when test="type='SIGNALBACK'">
    void IStub_method_<xsl:value-of select="$method_name"/>.on_return(
        UInt32 _msg_num,
        Address _proxy_addr,
        Int32 _err,
        Double _elapsed)
    {
        Output.Log(string.Format(
            "<xsl:value-of select="$class_name"/>."+
            "IStub_method_<xsl:value-of select="$method_name"/>.on_return("+
            " {3}[_proxy_addr.ip={0}, _proxy_addr.port={1:D}], _elapsed={2:F})",
            Util.inet_ntoa(_proxy_addr.ip), _proxy_addr.port, _elapsed, _proxy_addr.id));
    }<xsl:text/>
              </xsl:when>


              <xsl:when test="type='EVENT'">
    Int32 IStub_method_<xsl:value-of select="$method_name"/>.on_link(
        Address _proxy_addr,
        Double _elapsed,
        Double _limit)
    {
        Output.Log(string.Format(
            "<xsl:value-of select="$class_name"/>."+
            "IStub_method_<xsl:value-of select="$method_name"/>.on_link("+
            " {4}[_proxy_addr.ip={0}, _proxy_addr.port={1:D}],"+
            " _elapsed={2:F}, _limit={3:F})",
            Util.inet_ntoa(_proxy_addr.ip), _proxy_addr.port,
            _elapsed, _limit, _proxy_addr.id));
        return 0;
    }<xsl:text/>

    void IStub_method_<xsl:value-of select="$method_name"/>.on_unlink(
        Address _proxy_addr,
        Int32 _err)
    {
        Output.Log(string.Format(
            "<xsl:value-of select="$class_name"/>."+
            "IStub_method_<xsl:value-of select="$method_name"/>.on_unlink("+
            " {3}[_proxy_addr.ip={0}, _proxy_addr.port={1:D}], _err={2:D})",
            Util.inet_ntoa(_proxy_addr.ip), _proxy_addr.port, _err, _proxy_addr.id));
    }<xsl:text/>
              </xsl:when>
              <xsl:when test="type='COMMAND'">
    Int32 IStub_method_<xsl:value-of select="$method_name"/>.on_link(
        Address _proxy_addr,
        Double _elapsed,
        Double _limit)
    {
        Output.Log(string.Format(
            "<xsl:value-of select="$class_name"/>."+
            "IStub_method_<xsl:value-of select="$method_name"/>.on_link("+
            " {4}[_proxy_addr.ip={0}, _proxy_addr.port={1:D}],"+
            " _elapsed={2:F}, _limit={3:F})",
            Util.inet_ntoa(_proxy_addr.ip), _proxy_addr.port,
            _elapsed, _limit, _proxy_addr.id));
        return 0;
    }<xsl:text/>

    void IStub_method_<xsl:value-of select="$method_name"/>.on_unlink(
        Address _proxy_addr,
        Int32 _err)
    {
        Output.Log(string.Format(
            "<xsl:value-of select="$class_name"/>."+
            "IStub_method_<xsl:value-of select="$method_name"/>.on_unlink("+
            " {3}[_proxy_addr.ip={0}, _proxy_addr.port={1:D}], _err={2:D})",
            Util.inet_ntoa(_proxy_addr.ip), _proxy_addr.port, _err, _proxy_addr.id));
    }<xsl:text/>

    void IStub_method_<xsl:value-of select="$method_name"/>.on_sync(
        Address _proxy_addr,
        Sync_model _sync_model,
        double _elapsed,
        double _limit<xsl:if test="in_data!='(null)'">,
        ref Nerv36.Data.<xsl:value-of select="substring($in_data_domain_namespace,2)"/>.<xsl:value-of select="in_data"/> _cmd_dat_</xsl:if>)
    {
        Output.Log(string.Format(
            "<xsl:value-of select="$class_name"/>."+
            "IStub_method_<xsl:value-of select="$method_name"/>.on_sync("+
            " {5}[_proxy_addr.ip={0}, _proxy_addr.port={1:D}], _sync_model={2:D},"+
            " _elapsed={3:F}, _limit={4:F})",
            Util.inet_ntoa(_proxy_addr.ip), _proxy_addr.port, _sync_model,
            _elapsed, _limit, _proxy_addr.id));
        <xsl:if test="in_data!='(null)'">_cmd_dat_.print("<xsl:value-of select="in_data"/>");</xsl:if>
    }<xsl:text/>
              </xsl:when>
              <xsl:when test="type='INFORMATION'">
    Int32 IStub_method_<xsl:value-of select="$method_name"/>.on_link(
        Address _proxy_addr,
        Boolean _reliability,
        Double _elapsed,
        Double _limit)
    {
        Output.Log(string.Format(
            "<xsl:value-of select="$class_name"/>."+
            "IStub_method_<xsl:value-of select="$method_name"/>.on_link("+
            " {4}[_proxy_addr.ip={0}, _proxy_addr.port={1:D}],"+
            " _elapsed={2:F}, _limit={3:F})",
            Util.inet_ntoa(_proxy_addr.ip), _proxy_addr.port,
            _elapsed, _limit, _proxy_addr.id));
        return 0;
    }<xsl:text/>

    void IStub_method_<xsl:value-of select="$method_name"/>.on_unlink(
        Address _proxy_addr,
        Int32 _err)
    {
        Output.Log(string.Format(
            "<xsl:value-of select="$class_name"/>."+
            "IStub_method_<xsl:value-of select="$method_name"/>.on_unlink("+
            " {3}[_proxy_addr.ip={0}, _proxy_addr.port={1:D}], _err={2:D})",
            Util.inet_ntoa(_proxy_addr.ip), _proxy_addr.port, _err, _proxy_addr.id));
    }<xsl:text/>
              </xsl:when>
            </xsl:choose>
          </xsl:for-each>
        </xsl:for-each>
      </xsl:for-each>
    </xsl:for-each>
}
  </xsl:for-each>
</xsl:template>
</xsl:stylesheet>
