<?xml version="1.0" encoding="utf-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:include href="../../../xsl_util.xsl"/>
<xsl:output method="text" encoding="utf-8" indent="yes" />
<xsl:template match="/">
<xsl:variable name="component_name">
  <xsl:call-template name="replace">
    <xsl:with-param name="text" select="nerv_icde/component/name" />
    <xsl:with-param name="replace" select="' '" />
    <xsl:with-param name="by" select="'_'" />
  </xsl:call-template>
</xsl:variable>
#pragma once

#include "Exam_<xsl:value-of select="$component_name"/>/Exam_<xsl:value-of select="$component_name"/>.hh"

<xsl:for-each select="/nerv_icde/component/proxy_list/row">
#include "Nerv_proxy/<xsl:value-of select="class_name"/>/<xsl:value-of select="class_name"/>.hh"
</xsl:for-each>
<xsl:for-each select="/nerv_icde/component/stub_list/row">
#include "Nerv_stub/<xsl:value-of select="class_name"/>/<xsl:value-of select="class_name"/>.hh"
</xsl:for-each>

#include &lt;stack&gt;
#include &lt;thread&gt;

namespace <xsl:value-of select="$component_name"/> {

// using namespace std;
using namespace std::this_thread;
using namespace std::chrono;
using namespace Nerv36::Data::Component;

class The_<xsl:value-of select="$component_name"/>
    : public Exam::Exam_<xsl:value-of select="$component_name"/>
  <xsl:for-each select="/nerv_icde/component/stub_list/row/object_list/row">
<xsl:text>
    </xsl:text>, Nerv_stub::I<xsl:value-of select="../../class_name"/>_
  </xsl:for-each>
  <xsl:for-each select="/nerv_icde/component/proxy_list/row/object_list/row">
<xsl:text>
    </xsl:text>, Nerv_proxy::I<xsl:value-of select="../../class_name"/>_
  </xsl:for-each>
{
public:
    The_<xsl:value-of select="$component_name"/>();
    ~The_<xsl:value-of select="$component_name"/>();

protected:
  <xsl:for-each select="/nerv_icde/component/stub_list/row/object_list/row">
<xsl:text>
    </xsl:text>Nerv_stub::<xsl:value-of select="../../class_name"/>*<xsl:text> </xsl:text>stub_<xsl:value-of select="object_name"/>_;<xsl:text/>
  </xsl:for-each>
  <xsl:for-each select="/nerv_icde/component/proxy_list/row/object_list/row">
<xsl:text>
    </xsl:text>Nerv_proxy::<xsl:value-of select="../../class_name"/>*<xsl:text> </xsl:text>proxy_<xsl:value-of select="object_name"/>_;<xsl:text/>
  </xsl:for-each>

    virtual void on_initialize();
};

} // namespace <xsl:value-of select="$component_name"/>

</xsl:template>
</xsl:stylesheet>
