
#pragma once
/******************************************************************************
    domain   : Component
    domain creator   : root
    domain create date : 2021-12-20 19:06:49
    domain description :
    data name : Error
    data writer   : root
    data description:
*******************************************************************************/
#include <Nerv36/Nerv.hh>
#include <stdio.h>
#include <string>

namespace Nerv36 {
namespace Data {
namespace Component {

typedef ::Nerv36::Enum32 Error;

constexpr Error ERROR_NONE = 0;

constexpr Error FILE_READ_ERROR = 1;

constexpr Error FILE_WRITE_ERROR = 2;

constexpr Error NETWORK_ERROR = 4;

constexpr Error DEVICE_ERROR = 8;

constexpr Error SPREAD_ERROR = 16;

inline const char* get_str_of_Error(Error _val)
{
    const char* str_ = 0;

    if(_val == ERROR_NONE) { str_ = "ERROR_NONE"; }
    else if(_val == FILE_READ_ERROR) {
        str_ = "FILE_READ_ERROR";
    }
    else if(_val == FILE_WRITE_ERROR) {
        str_ = "FILE_WRITE_ERROR";
    }
    else if(_val == NETWORK_ERROR) {
        str_ = "NETWORK_ERROR";
    }
    else if(_val == DEVICE_ERROR) {
        str_ = "DEVICE_ERROR";
    }
    else if(_val == SPREAD_ERROR) {
        str_ = "SPREAD_ERROR";
    }
    else {
        str_ = "UNKNOWN";
    }
    return str_;
}

typedef THistory_elem<Error> Error_history_elem;
typedef THistory<Error>      Error_history;

} // namespace Component
} // namespace Data
} // namespace Nerv36
