<?xml version="1.0" encoding="UTF-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="text" encoding="utf-8" indent="yes"/>


<xsl:template name ="template_call" >
  <xsl:variable name="in_data_domain_namespace">
    <xsl:call-template name="get_data_domain_namespace">
      <xsl:with-param name="data_domain_id" select="in_data_domain_id" />
    </xsl:call-template>
  </xsl:variable>
  <xsl:variable name="out_data_domain_namespace">
    <xsl:call-template name="get_data_domain_namespace">
      <xsl:with-param name="data_domain_id" select="out_data_domain_id" />
    </xsl:call-template>
  </xsl:variable>
// proxy
struct Proxy_method_<xsl:value-of select="name"/>_ {
    virtual void on_<xsl:value-of select="name"/>_return(Msg_num _msg_num,
                           Error _err,
                           <xsl:if test="out_data!='(null)'">const Nerv36::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>* _ret_dat_,</xsl:if> double _elapsed) = 0;
};

class Proxy_method_<xsl:value-of select="name"/> : public Nerv36::Proxy_call {
    virtual void on_return(Msg_num     _msg_num,
                        Error    _err,
                        const void* _ret_dat_,
                        Pksize      _ret_size,
                        double      _elapsed)
    {
        interface_-&gt;on_<xsl:value-of select="name"/>_return(_msg_num, _err,<xsl:if test="out_data!='(null)'"> (const Nerv36::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>*)_ret_dat_,</xsl:if> _elapsed);
    }

public:
    Proxy_method_<xsl:value-of select="name"/>_* interface_;

    Proxy_method_<xsl:value-of select="name"/>(
        const Proxy&amp; _proxy_,
        Proxy_method_<xsl:value-of select="name"/>_* _interface_)
        : Proxy(_proxy_)
        , Proxy_call(<xsl:value-of select="code"/>, _proxy_)
        , interface_(_interface_)
    {
    }

    ~Proxy_method_<xsl:value-of select="name"/>()
    {
    }

    <xsl:if test="in_data!='(null)'">
    Nerv36::Error delegate_call(Msg_num* _msg_num_, const Nerv36::Data<xsl:value-of select="$in_data_domain_namespace"/>::<xsl:value-of select="in_data"/>* _cal_dat_, double _limit = 1.0)
    {
        Error err;
        ::Nerv36::Pksize cal_size = _cal_dat_-&gt;fit_size();
        if( cal_size &lt; sizeof(Nerv36::Data<xsl:value-of select="$in_data_domain_namespace"/>::<xsl:value-of select="in_data"/>) ) {
            err = NERV_ERR_UNUSED_DYNAMIC_BUFFER_;
        }
        else {
            err = Nerv36::Proxy_call::delegate_call(_msg_num_, _cal_dat_, cal_size, _limit);
        }
        return err;
    }

    Nerv36::Error call(const Nerv36::Data<xsl:value-of select="$in_data_domain_namespace"/>::<xsl:value-of select="in_data"/>* _cal_dat_,<xsl:if test="out_data!='(null)'"> Nerv36::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>* _ret_dat_,</xsl:if> double _limit = 1.0, double* _elapsed_ = 0)
    {
        Error err;
        Promise* promise_ = async_call(_cal_dat_, _limit);
        err = await_return( promise_, <xsl:if test="out_data!='(null)'">_ret_dat_,</xsl:if> _elapsed_ );
        return err;

    }

    Nerv36::Promise* async_call( const Nerv36::Data<xsl:value-of select="$in_data_domain_namespace"/>::<xsl:value-of select="in_data"/>* _cal_dat_, double _limit = 1.0)
    {
        Nerv36::Promise* promise_;
        ::Nerv36::Pksize cal_size = _cal_dat_-&gt;fit_size();
        if( cal_size &lt; sizeof(Nerv36::Data<xsl:value-of select="$in_data_domain_namespace"/>::<xsl:value-of select="in_data"/>) ) {
            promise_ = 0;
        }
        else {
            promise_ = Nerv36::Proxy_call::async_call(_cal_dat_, cal_size, _limit);
        }
        return promise_;
    }

    Nerv36::Error await_return(Nerv36::Promise* _promise_, <xsl:if test="out_data!='(null)'"> Nerv36::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>* _return_data_,</xsl:if> double*  _elapsed_)
    {
        Error err;
        if( _promise_ ) {
            <xsl:if test="out_data!='(null)'">Nerv36::Pksize out_size = sizeof(Nerv36::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>);</xsl:if>
            err = Nerv36::Proxy_call::await_return( _promise_, <xsl:choose><xsl:when test="out_data!='(null)'">_return_data_,&amp;out_size,</xsl:when><xsl:when test="out_data='(null)'">0, 0,</xsl:when></xsl:choose> _elapsed_ );
        }
        else {
            err = NERV_ERR_UNUSED_DYNAMIC_BUFFER_;
        }
        return err;
    }
    </xsl:if>
    <xsl:if test="in_data='(null)'">
    Nerv36::Error delegate_call(Msg_num* _msg_num_, double _limit = 1.0)
    {
        Error err;
        err = Nerv36::Proxy_call::delegate_call(_msg_num_, 0, 0, _limit);
        return err;
    }

    Nerv36::Error call(<xsl:if test="out_data!='(null)'"> Nerv36::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>* _ret_dat_,</xsl:if> double _limit = 1.0, double* _elapsed_ = 0)
    {
        Error err;
        Nerv36::Promise* promise_ = async_call( _limit);
        err = await_return( promise_, <xsl:if test="out_data!='(null)'">_ret_dat_,</xsl:if> _elapsed_ );
        return err;
    }

    Nerv36::Promise* async_call(double _limit = 1.0)
    {
        Nerv36::Promise* promise_ = Nerv36::Proxy_call::async_call(0, 0, _limit);
        return promise_;
    }

        <xsl:if test="out_data!='(null)'">
    Nerv36::Error await_return(Nerv36::Promise* _promise_,  Nerv36::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>* _ret_dat_, double*  _elapsed_)
    {
        Error err;
        Nerv36::Pksize ret_size = sizeof(Nerv36::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>);
        err = Nerv36::Proxy_call::await_return( _promise_, _ret_dat_,&amp;ret_size, _elapsed_ );
        return err;
    }
        </xsl:if>
        <xsl:if test="out_data='(null)'">
    Nerv36::Error await_return(Promise* _promise_, double*  _elapsed_)
    {
        Error err;
        err = Nerv36::Proxy_call::await_return( _promise_, 0, 0, _elapsed_ );
        return err;
    }
        </xsl:if>
    </xsl:if>

    //void cancel(Error _err)
    //{
    //    cancel(_err);
    //}
};

// stub
struct Stub_method_<xsl:value-of select="name"/>_ {
    virtual Nerv36::Error on_<xsl:value-of select="name"/>( Address _proxy_addr, <xsl:if test="in_data!='(null)'">const Nerv36::Data<xsl:value-of select="$in_data_domain_namespace"/>::<xsl:value-of select="in_data"/>* _cal_dat_,</xsl:if> <xsl:if test="out_data!='(null)'">Nerv36::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>* _ret_dat_,</xsl:if> double _elapsed, double _limit) = 0;
    virtual void on_<xsl:value-of select="name"/>_cancel(Address _proxy_addr, Error _err) = 0;
};
class Stub_method_<xsl:value-of select="name"/> : public Nerv36::Stub_call {

    virtual ::Nerv36::Error on_call(Address     _proxy_addr,
                                    const void* _cal_dat_,
                                    Pksize      _cal_size,
                                    void*       _ret_dat_,
                                    Pksize*     _ret_size_,
                                    double      _elapsed,
                                    double      _limit )
    {
        <xsl:if test="out_data!='(null)'">
        auto _ret_data_ = (Nerv36::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>*)_ret_dat_;
        _ret_data_-&gt;init_dynamic_buffer(*_ret_size_ - sizeof(Nerv36::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>));
        </xsl:if>
        ::Nerv36::Error err = interface_-&gt;on_<xsl:value-of select="name"/>(_proxy_addr,<xsl:if test="in_data!='(null)'"> (const Nerv36::Data<xsl:value-of select="$in_data_domain_namespace"/>::<xsl:value-of select="in_data"/>*)_cal_dat_,</xsl:if><xsl:if test="out_data!='(null)'"> (Nerv36::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>*)_ret_dat_,</xsl:if> _elapsed, _limit);
<xsl:if test="out_data!='(null)'">
        if( ! err ) {
            Pksize ret_size;
            ret_size = ((Nerv36::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>*)_ret_dat_)->fit_size();
            if( ret_size &lt; sizeof(Nerv36::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>)){
                *_ret_size_ = 0;
                err = NERV_ERR_UNUSED_DYNAMIC_BUFFER_;
            }
            else {
                *_ret_size_ = ret_size;
            }
        }
</xsl:if>
        return err;
    }

    virtual void on_call_cancel( Address _proxy_addr, Error _err)
    {
        interface_-&gt;on_<xsl:value-of select="name"/>_cancel(_proxy_addr, _err);
    }

public:

    Stub_method_<xsl:value-of select="name"/>_* interface_;

    Stub_method_<xsl:value-of select="name"/>(
        const Stub&amp; _stub_,
        Stub_method_<xsl:value-of select="name"/>_* _interface_)
        : Stub(_stub_)
        , Stub_call(<xsl:value-of select="code"/>, <xsl:if test="out_data!='(null)'">sizeof(Nerv36::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>)</xsl:if><xsl:if test="out_data='(null)'">0</xsl:if>, _stub_)
        , interface_(_interface_)
    {
    }

    ~Stub_method_<xsl:value-of select="name"/>()
    {
    }
};
</xsl:template>




</xsl:stylesheet>
