<?xml version="1.0" encoding="utf-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:include href="../../../../xsl_util.xsl"/>

<xsl:output method="text" encoding="utf-8" indent="yes"/>

<xsl:param name = "export_proxy_class_id" />

<xsl:template match="/">


  <xsl:for-each select="/nerv_icde/component/proxy_list/row[id=$export_proxy_class_id]">
    <xsl:variable name="method_domain_id" select="method_domain_id" />
    <xsl:variable name="interface_name" select="interface_name" />
    <xsl:variable name="class_name" select="class_name" />

#include "<xsl:value-of select="$class_name"/>_exam.hh"

#include &lt;examout.hh&gt;

namespace Exam {
namespace Nerv_proxy {

<xsl:value-of select="$class_name"/>_exam::<xsl:value-of select="$class_name"/>_exam(Proxy_<xsl:value-of select="$interface_name"/>_* _interface_) :
    Proxy_<xsl:value-of select="$interface_name"/>(_interface_? _interface_ : this)
{
}

<xsl:value-of select="$class_name"/>_exam::~<xsl:value-of select="$class_name"/>_exam()
{
}

void <xsl:value-of select="$class_name"/>_exam::on_connect()
{
    fprintf(examout_, "<xsl:value-of select="$class_name"/>_exam::on_connect\n");
    Nerv36::Error err = 0;
    Nerv36::Msg_num msg_num = 0;

    double connect_timeout = 1.0;
  <xsl:for-each select="/nerv_icde/methoddomain/row[id=$method_domain_id]">
    <xsl:for-each select="interface/row[name=$interface_name]">
      <xsl:for-each select="membermethod/row">
        <xsl:variable name="method_name" select="method_name" />
        <xsl:for-each select="../../../../method/row[name=$method_name]">
          <xsl:if test="type='COMMAND' or type='EVENT' or type='INFORMATION'">
    msg_num = 0;
    fprintf(examout_, "<xsl:value-of select="$class_name"/>_exam::<xsl:value-of select="name"/>_delegate_link()\n");<xsl:text/>
    err = <xsl:value-of select="name"/>.delegate_link(&amp;msg_num, <xsl:if test="type='INFORMATION'">false, </xsl:if> connect_timeout );
    fprintf(examout_, "<xsl:value-of select="$class_name"/>_exam::<xsl:value-of select="name"/>_delegate_link(%d) = %s\n" , msg_num, Nerv36::get_err_str(err) );<xsl:text/>
          </xsl:if>
        </xsl:for-each>
      </xsl:for-each>
    </xsl:for-each>
  </xsl:for-each>
}

void <xsl:value-of select="$class_name"/>_exam::on_disconnect()
{
    fprintf(examout_, "<xsl:value-of select="$class_name"/>_exam::on_disconnect\n");
    stop();
}

    <xsl:for-each select="/nerv_icde/methoddomain/row[id=$method_domain_id]">
      <xsl:for-each select="interface/row[name=$interface_name]">
        <xsl:for-each select="membermethod/row">
          <xsl:variable name="method_name" select="method_name" />
          <xsl:for-each select="../../../../method/row[name=$method_name]">

            <xsl:variable name="in_data_domain_namespace">
              <xsl:call-template name="get_data_domain_namespace">
                <xsl:with-param name="data_domain_id" select="in_data_domain_id" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="out_data_domain_namespace">
              <xsl:call-template name="get_data_domain_namespace">
                <xsl:with-param name="data_domain_id" select="out_data_domain_id" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="type='CALLBACK'">
::Nerv36::Error <xsl:value-of select="$class_name"/>_exam::on_<xsl:value-of select="$method_name"/>( <xsl:if test="out_data!='(null)'">const Nerv36::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>* _clb_dat_, </xsl:if><xsl:if test="in_data!='(null)'">Nerv36::Data<xsl:value-of select="$in_data_domain_namespace"/>::<xsl:value-of select="in_data"/>* _ret_dat_, </xsl:if> double _elapsed, double _limit)
{
    fprintf(examout_, "<xsl:value-of select="$class_name"/>_exam::callback::on_<xsl:value-of select="$method_name"/>\n");
    return 0;
}
void <xsl:value-of select="$class_name"/>_exam::on_<xsl:value-of select="$method_name"/>_cancel( ::Nerv36::Error _err)
{
    fprintf(examout_, "<xsl:value-of select="$class_name"/>_exam::callback::on_<xsl:value-of select="$method_name"/>_cancel\n");
}
              </xsl:when>
              <xsl:when test="type='SIGNALBACK'">
void <xsl:value-of select="$class_name"/>_exam::on_<xsl:value-of select="$method_name"/>( <xsl:if test="out_data!='(null)'">const ::Nerv36::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>* _sgb_dat_,</xsl:if> double _elapsed)
{
    fprintf(examout_, "<xsl:value-of select="$class_name"/>_exam::signalback::on_<xsl:value-of select="$method_name"/>\n");
}
void <xsl:value-of select="$class_name"/>_exam::on_<xsl:value-of select="$method_name"/>_cancel( ::Nerv36::Error _err)
{
    fprintf(examout_, "<xsl:value-of select="$class_name"/>_exam::signalback::on_<xsl:value-of select="$method_name"/>_cancel\n");
}
              </xsl:when>
              <xsl:when test="type='CALL'">
void <xsl:value-of select="$class_name"/>_exam::on_<xsl:value-of select="$method_name"/>_return(Nerv36::Msg_num _msg_num, Nerv36::Error _err,<xsl:if test="out_data!='(null)'"> const Nerv36::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>* _ret_dat_,</xsl:if> double _elapsed)
{
    fprintf(examout_, "<xsl:value-of select="$class_name"/>_exam::call::on_<xsl:value-of select="$method_name"/>_return\n");
}
              </xsl:when>
              <xsl:when test="type='SIGNAL'">
void <xsl:value-of select="$class_name"/>_exam::on_<xsl:value-of select="$method_name"/>_return(Nerv36::Msg_num _msg_num, Nerv36::Error _err, double _elapsed)
{
    fprintf(examout_, "<xsl:value-of select="$class_name"/>_exam::signal::on_<xsl:value-of select="$method_name"/>_return\n");
}
              </xsl:when>
              <xsl:when test="type='EVENT'">
void <xsl:value-of select="$class_name"/>_exam::on_<xsl:value-of select="$method_name"/>_link(Nerv36::Msg_num _msg_num, Nerv36::Error _err, double _elapsed)
{
    fprintf(examout_, "<xsl:value-of select="$class_name"/>_exam::event::on_<xsl:value-of select="$method_name"/>_link\n");
}

void <xsl:value-of select="$class_name"/>_exam::on_<xsl:value-of select="$method_name"/>_unlink(Nerv36::Error _err)
{
    fprintf(examout_, "<xsl:value-of select="$class_name"/>_exam::event::on_<xsl:value-of select="$method_name"/>_unlink\n");
}
                <xsl:choose >
                  <xsl:when test="out_data='(null)'">
void <xsl:value-of select="$class_name"/>_exam::on_<xsl:value-of select="$method_name"/>( double _elapsed)
{
    fprintf(examout_, "<xsl:value-of select="$class_name"/>_exam::event::on_<xsl:value-of select="$method_name"/>\n");
}
                  </xsl:when>
                  <xsl:otherwise>
void <xsl:value-of select="$class_name"/>_exam::on_<xsl:value-of select="$method_name"/>(const Nerv36::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>* _evt_dat_, double _elapsed)
{
    fprintf(examout_, "<xsl:value-of select="$class_name"/>_exam::event::on_<xsl:value-of select="$method_name"/>\n");
}
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:when>


              <xsl:when test="type='COMMAND'">
void <xsl:value-of select="$class_name"/>_exam::on_<xsl:value-of select="$method_name"/>_link(Nerv36::Msg_num _msg_num, Nerv36::Error _err, double _elapsed)
{
    fprintf(examout_, "<xsl:value-of select="$class_name"/>_exam::command::on_<xsl:value-of select="$method_name"/>_link\n");
}
void <xsl:value-of select="$class_name"/>_exam::on_<xsl:value-of select="$method_name"/>_unlink(Nerv36::Error _err)
{
    fprintf(examout_, "<xsl:value-of select="$class_name"/>_exam::command::on_<xsl:value-of select="$method_name"/>_unlink\n");
}
              </xsl:when>


              <xsl:when test="type='INFORMATION'">
void <xsl:value-of select="$class_name"/>_exam::on_<xsl:value-of select="$method_name"/>_link(Nerv36::Msg_num _msg_num, Nerv36::Error _err, double _elapsed)
{
    fprintf(examout_, "<xsl:value-of select="$class_name"/>_exam::information::on_<xsl:value-of select="$method_name"/>_link\n");
}
void <xsl:value-of select="$class_name"/>_exam::on_<xsl:value-of select="$method_name"/>_unlink(Nerv36::Error _err)
{
    fprintf(examout_, "<xsl:value-of select="$class_name"/>_exam::information::on_<xsl:value-of select="$method_name"/>_unlink\n");
}
                <xsl:choose >
                  <xsl:when test="out_data='(null)'">
void <xsl:value-of select="$class_name"/>_exam::on_<xsl:value-of select="$method_name"/>_sync( Nerv36::Sync_model _sync_model, double _elapsed, double _limit )
{
    fprintf(examout_, "<xsl:value-of select="$class_name"/>_exam::information::on_<xsl:value-of select="$method_name"/>_sync\n");
}
                  </xsl:when>
                  <xsl:otherwise>
void <xsl:value-of select="$class_name"/>_exam::on_<xsl:value-of select="$method_name"/>_sync( Nerv36::Sync_model _sync_model, double _elapsed, double _limit, const Nerv36::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>* _buffer_ )
{
    fprintf(examout_, "<xsl:value-of select="$class_name"/>_exam::information::on_<xsl:value-of select="$method_name"/>_sync\n");
}
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:when>


              <xsl:when test="type='BROADCAST'">
                <xsl:choose >
                  <xsl:when test="out_data='(null)'">
void <xsl:value-of select="$class_name"/>_exam::on_<xsl:value-of select="$method_name"/>( ::Nerv36::Address _stub_addr, double _elapsed)
{
    fprintf(examout_, "<xsl:value-of select="$class_name"/>_exam::datagram::on_<xsl:value-of select="$method_name"/>\n");
}
                  </xsl:when>
                  <xsl:otherwise>
void <xsl:value-of select="$class_name"/>_exam::on_<xsl:value-of select="$method_name"/>( ::Nerv36::Address _stub_addr, const Nerv36::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>* _buf_, double _elapsed)
{
    fprintf(examout_, "<xsl:value-of select="$class_name"/>_exam::datagram::on_<xsl:value-of select="$method_name"/>\n");
}
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:when>
            </xsl:choose>
          </xsl:for-each>
        </xsl:for-each>
      </xsl:for-each>
    </xsl:for-each>
  </xsl:for-each>

} // namespace Nerv_proxy
} // namespace Exam

</xsl:template>

</xsl:stylesheet>
