<?xml version="1.0" encoding="utf-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="xml" encoding="utf-8" indent="yes"/>




<xsl:template name="struct_field_count_position">
	<xsl:param name="data_domain_path"/>
	<xsl:param name="data"/>
	<xsl:param name="position"/>

	<xsl:for-each select="/nerv_system_interface/data_domains/data_domain[path=$data_domain_path]/datas/data[name=$data]">
		<xsl:for-each select="datafields/datafield">
			<xsl:if test="position() &lt; $position" >
				<xsl:choose>
					<xsl:when test="type='alias'">
						<xsl:call-template name="struct_field_count">
							<xsl:with-param name="data_domain_path" select="real_domain_path" />
							<xsl:with-param name="data" select="real_data" />
						</xsl:call-template>
					</xsl:when>
					<xsl:otherwise>1</xsl:otherwise>
				</xsl:choose>
			</xsl:if>
		</xsl:for-each>
	</xsl:for-each>
</xsl:template>




<xsl:template name="struct_field_count">
	<xsl:param name="data_domain_path"/>
	<xsl:param name="data"/>
	<xsl:for-each select="/nerv_system_interface/data_domains/data_domain[path=$data_domain_path]/datas/data[name=$data]">
		<xsl:choose>
			<xsl:when test="type='alias'">
				<xsl:call-template name="struct_field_count">
					<xsl:with-param name="data_domain_path" select="real_domain_path" />
					<xsl:with-param name="data" select="real_data" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="type='struct'">
				<xsl:for-each select="datafields/datafield">
					<xsl:choose>
						<xsl:when test="type='alias'">
							<xsl:call-template name="struct_field_count">
								<xsl:with-param name="data_domain_path" select="real_domain_path" />
								<xsl:with-param name="data" select="real_data" />
							</xsl:call-template>
						</xsl:when>
						<xsl:otherwise>1</xsl:otherwise>
					</xsl:choose>
				</xsl:for-each>
			</xsl:when>
			<xsl:otherwise>1</xsl:otherwise>
		</xsl:choose>
	</xsl:for-each>
</xsl:template>


<xsl:template name="chapter_3.2.5.3.1.data_field">
	<xsl:param name="data_domain_path"/>
	<xsl:param name="data"/>

	<xsl:variable name="struct_field_count_string">
		<xsl:call-template name="struct_field_count">
			<xsl:with-param name="data_domain_path" select="$data_domain_path" />
			<xsl:with-param name="data" select="$data" />
		</xsl:call-template>
	</xsl:variable>
	<xsl:variable name="struct_field_count">
		<xsl:value-of select="string-length($struct_field_count_string)"/>
	</xsl:variable>


	<TABLE BorderFill="4" CellSpacing="0" ColCount="6" PageBreak="Cell" RepeatHeader="true" RowCount="2">
		<xsl:attribute name="RowCount"><xsl:value-of select="$struct_field_count+1"/></xsl:attribute>
		<SHAPEOBJECT InstId="1195095296" Lock="false" NumberingType="Table" ZOrder="20">
			<SIZE Height="4268" HeightRelTo="Absolute" Protect="false" Width="44000" WidthRelTo="Absolute"/>
			<POSITION AffectLSpacing="false" AllowOverlap="false" FlowWithText="true" HoldAnchorAndSO="false" HorzAlign="Left" HorzOffset="0" HorzRelTo="Para" TreatAsChar="false" VertAlign="Top" VertOffset="0" VertRelTo="Para"/>
			<OUTSIDEMARGIN Bottom="283" Left="283" Right="283" Top="283"/>
			<CAPTION FullSize="false" Gap="850" LastWidth="46492" Side="Top" Width="8504">
				<PARALIST LineWrap="Break" LinkListID="0" LinkListIDNext="0" TextDirection="0" VertAlign="Top">
					<P ParaShape="27" Style="0">
						<TEXT CharShape="2">
							<CHAR>표 </CHAR>
							<AUTONUM Number="10" NumberType="Table">
								<AUTONUMFORMAT Superscript="false" Type="Digit"/>
							</AUTONUM>
							<CHAR> 데이터 요소</CHAR>
						</TEXT>
					</P>
				</PARALIST>
			</CAPTION>
		</SHAPEOBJECT>
		<INSIDEMARGIN Bottom="567" Left="850" Right="850" Top="567"/>
		<ROW>
			<CELL BorderFill="9" ColAddr="0" ColSpan="1" Dirty="false" Editable="false" HasMargin="false" Header="true" Height="2134" Protect="false" RowAddr="0" RowSpan="1" Width="3000">
				<CELLMARGIN Bottom="100" Left="100" Right="100" Top="100"/>
				<PARALIST LineWrap="Break" LinkListID="0" LinkListIDNext="0" TextDirection="0" VertAlign="Center">
					<P ParaShape="32" Style="23">
						<TEXT CharShape="20">
							<CHAR>No</CHAR>
						</TEXT>
					</P>
				</PARALIST>
			</CELL>
			<CELL BorderFill="9" ColAddr="1" ColSpan="1" Dirty="false" Editable="false" HasMargin="false" Header="true" Height="2134" Protect="false" RowAddr="0" RowSpan="1" Width="10000">
				<CELLMARGIN Bottom="100" Left="100" Right="100" Top="100"/>
				<PARALIST LineWrap="Break" LinkListID="0" LinkListIDNext="0" TextDirection="0" VertAlign="Center">
					<P ParaShape="32" Style="23">
						<TEXT CharShape="20">
							<CHAR>요소</CHAR>
						</TEXT>
					</P>
				</PARALIST>
			</CELL>
			<CELL BorderFill="9" ColAddr="2" ColSpan="1" Dirty="false" Editable="false" HasMargin="false" Header="true" Height="2134" Protect="false" RowAddr="0" RowSpan="1" Width="10000">
				<CELLMARGIN Bottom="100" Left="100" Right="100" Top="100"/>
				<PARALIST LineWrap="Break" LinkListID="0" LinkListIDNext="0" TextDirection="0" VertAlign="Center">
					<P ParaShape="32" Style="23">
						<TEXT CharShape="20">
							<CHAR>설명</CHAR>
						</TEXT>
					</P>
				</PARALIST>
			</CELL>
			<CELL BorderFill="9" ColAddr="3" ColSpan="1" Dirty="false" Editable="false" HasMargin="false" Header="true" Height="2134" Protect="false" RowAddr="0" RowSpan="1" Width="7000">
				<CELLMARGIN Bottom="100" Left="100" Right="100" Top="100"/>
				<PARALIST LineWrap="Break" LinkListID="0" LinkListIDNext="0" TextDirection="0" VertAlign="Center">
					<P ParaShape="32" Style="23">
						<TEXT CharShape="20">
							<CHAR>형태크기</CHAR>
						</TEXT>
					</P>
					<P ParaShape="32" Style="23">
						<TEXT CharShape="20">
							<CHAR>: 비트크기</CHAR>
						</TEXT>
					</P>
					<P ParaShape="32" Style="23">
						<TEXT CharShape="20">
							<CHAR>[배열크기]</CHAR>
						</TEXT>
					</P>
				</PARALIST>
			</CELL>
			<CELL BorderFill="9" ColAddr="4" ColSpan="1" Dirty="false" Editable="false" HasMargin="false" Header="true" Height="2134" Protect="false" RowAddr="0" RowSpan="1" Width="10000">
				<CELLMARGIN Bottom="100" Left="100" Right="100" Top="100"/>
				<PARALIST LineWrap="Break" LinkListID="0" LinkListIDNext="0" TextDirection="0" VertAlign="Center">
					<P ParaShape="32" Style="23">
						<TEXT CharShape="20">
							<CHAR>범위</CHAR>
						</TEXT>
					</P>
				</PARALIST>
			</CELL>
			<CELL BorderFill="9" ColAddr="5" ColSpan="1" Dirty="false" Editable="false" HasMargin="false" Header="true" Height="2134" Protect="false" RowAddr="0" RowSpan="1" Width="4000">
				<CELLMARGIN Bottom="100" Left="100" Right="100" Top="100"/>
				<PARALIST LineWrap="Break" LinkListID="0" LinkListIDNext="0" TextDirection="0" VertAlign="Center">
					<P ParaShape="32" Style="23">
						<TEXT CharShape="20">
							<CHAR>단위</CHAR>
						</TEXT>
					</P>
				</PARALIST>
			</CELL>
		</ROW>
		<xsl:call-template name="struct_content">
			<xsl:with-param name="struct_field_count" select="1" />
			<xsl:with-param name="data_domain_path" select="$data_domain_path" />
			<xsl:with-param name="data" select="$data" />
			<xsl:with-param name="size" select="1" />
		</xsl:call-template>
	</TABLE>
</xsl:template>

<xsl:template name="struct_content">
	<xsl:param name="struct_field_count"/>
	<xsl:param name="data_domain_path"/>
	<xsl:param name="data"/>
	<xsl:param name="size"/>
	<xsl:param name="bitsize"/>

	<xsl:for-each select="/nerv_system_interface/data_domains/data_domain[path=$data_domain_path]/datas/data[name=$data]">
		<xsl:choose>
			<xsl:when test="type='struct'">
				<xsl:for-each select="datafields/datafield">

					<xsl:variable name="member_field_count_string">
						<xsl:call-template name="struct_field_count_position">
							<xsl:with-param name="data_domain_path" select="$data_domain_path" />
							<xsl:with-param name="data" select="$data" />
							<xsl:with-param name="position" select="position()" />
						</xsl:call-template>
					</xsl:variable>
					<xsl:variable name="member_field_count">
						<xsl:value-of select="string-length($member_field_count_string)"/>
					</xsl:variable>

					<xsl:choose>
						<xsl:when test="type='alias'">
							<xsl:call-template name="struct_content">
								<xsl:with-param name="struct_field_count" select="$struct_field_count + $member_field_count"/>
								<xsl:with-param name="data_domain_path" select="real_domain_path" />
								<xsl:with-param name="data" select="real_data" />
								<xsl:with-param name="size" select="$size" />
								<xsl:with-param name="bitsize" select="bitsize" />
							</xsl:call-template>
						</xsl:when>
						<xsl:otherwise>
							<xsl:call-template name="data_field">
								<xsl:with-param name="RowAddr" select="$struct_field_count + $member_field_count" />
								<xsl:with-param name="col_1" select="$struct_field_count + $member_field_count" />
								<xsl:with-param name="col_2" select="member_name" />
								<xsl:with-param name="col_3" select="description" />
								<xsl:with-param name="col_4_1" select="type"/>
								<xsl:with-param name="col_4_2">
									<xsl:if test="arraytype='FIX'">[<xsl:value-of select="arraysize"/>]</xsl:if>
									<xsl:if test="arraytype='VARIABLE'">[ MAX <xsl:value-of select="arraysize"/>]</xsl:if>
									<xsl:if test="bitsize!='0'"> :<xsl:value-of select="bitsize"/></xsl:if>
								</xsl:with-param>
								<xsl:with-param name="col_5">
									<xsl:value-of select="scmin"/> ~ <xsl:value-of select="scmax"/>
								</xsl:with-param>
								<xsl:with-param name="col_6" select="physical" />
							</xsl:call-template>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:for-each>
			</xsl:when>
			<xsl:when test="type='alias'">
				<xsl:call-template name="struct_content">
					<xsl:with-param name="struct_field_count" select="$struct_field_count" />
					<xsl:with-param name="data_domain_path" select="real_domain_path" />
					<xsl:with-param name="data" select="real_data" />
					<xsl:with-param name="size" select="$size" />
					<xsl:with-param name="bitsize" select="$bitsize" />
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>

				<!-- <xsl:value-of select="$member_field_count_string"/> -->

				<xsl:call-template name="data_field">
					<xsl:with-param name="RowAddr" select="$struct_field_count" />
					<xsl:with-param name="col_1" select="$struct_field_count" />
					<xsl:with-param name="col_2" select="name" />
					<xsl:with-param name="col_3" select="description" />
					<xsl:with-param name="col_4_1" select="type"/>
					<xsl:with-param name="col_4_2">
						<xsl:if test="$bitsize &gt; 0"> : <xsl:value-of select="$bitsize"/></xsl:if>
					</xsl:with-param>
					<xsl:with-param name="col_5">
						<xsl:value-of select="scmin"/> ~ <xsl:value-of select="scmax"/>
					</xsl:with-param>
					<xsl:with-param name="col_6" select="physical" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:for-each>

</xsl:template>

<xsl:template name="data_field">
	<xsl:param name="RowAddr"/>
	<xsl:param name="col_1"/>
	<xsl:param name="col_2"/>
	<xsl:param name="col_3"/>
	<xsl:param name="col_4_1"/>
	<xsl:param name="col_4_2"/>
	<xsl:param name="col_5"/>
	<xsl:param name="col_6"/>

	<ROW>
		<CELL BorderFill="4" ColAddr="0" ColSpan="1" Dirty="false" Editable="false" HasMargin="false" Header="false" Height="2134" Protect="false" RowAddr="1" RowSpan="1" Width="3000">
			<xsl:attribute name="RowAddr"><xsl:value-of select="$RowAddr"/></xsl:attribute>
			<CELLMARGIN Bottom="100" Left="100" Right="100" Top="100"/>
			<PARALIST LineWrap="Break" LinkListID="0" LinkListIDNext="0" TextDirection="0" VertAlign="Center">
				<P ParaShape="32" Style="24">
					<TEXT CharShape="21"><CHAR><xsl:value-of select="$col_1"/></CHAR></TEXT>
				</P>
			</PARALIST>
		</CELL>
		<CELL BorderFill="4" ColAddr="1" ColSpan="1" Dirty="false" Editable="false" HasMargin="false" Header="false" Height="2134" Protect="false" RowAddr="1" RowSpan="1" Width="10000">
			<xsl:attribute name="RowAddr"><xsl:value-of select="$RowAddr"/></xsl:attribute>
			<CELLMARGIN Bottom="100" Left="100" Right="100" Top="100"/>
			<PARALIST LineWrap="Break" LinkListID="0" LinkListIDNext="0" TextDirection="0" VertAlign="Center">
				<P ParaShape="32" Style="24">
					<TEXT CharShape="21"><CHAR><xsl:value-of select="$col_2"/></CHAR></TEXT>
				</P>
			</PARALIST>
		</CELL>
		<CELL BorderFill="4" ColAddr="2" ColSpan="1" Dirty="false" Editable="false" HasMargin="false" Header="false" Height="2134" Protect="false" RowAddr="1" RowSpan="1" Width="10000">
			<xsl:attribute name="RowAddr"><xsl:value-of select="$RowAddr"/></xsl:attribute>
			<CELLMARGIN Bottom="100" Left="100" Right="100" Top="100"/>
			<PARALIST LineWrap="Break" LinkListID="0" LinkListIDNext="0" TextDirection="0" VertAlign="Center">
				<P ParaShape="32" Style="24">
					<TEXT CharShape="21"><CHAR><xsl:value-of select="$col_3"/></CHAR></TEXT>
				</P>
			</PARALIST>
		</CELL>
		<CELL BorderFill="4" ColAddr="3" ColSpan="1" Dirty="false" Editable="false" HasMargin="false" Header="false" Height="2134" Protect="false" RowAddr="1" RowSpan="1" Width="7000">
			<xsl:attribute name="RowAddr"><xsl:value-of select="$RowAddr"/></xsl:attribute>
			<CELLMARGIN Bottom="100" Left="100" Right="100" Top="100"/>
			<PARALIST LineWrap="Break" LinkListID="0" LinkListIDNext="0" TextDirection="0" VertAlign="Center">
				<P ParaShape="32" Style="24">
					<TEXT CharShape="21"><CHAR><xsl:value-of select="$col_4_1"/></CHAR></TEXT>
				</P>
				<xsl:if test="$col_4_2!=''">
				<P ParaShape="32" Style="24">
					<TEXT CharShape="21"><CHAR><xsl:value-of select="$col_4_2"/></CHAR></TEXT>
				</P>
				</xsl:if>
			</PARALIST>
		</CELL>
		<CELL BorderFill="4" ColAddr="4" ColSpan="1" Dirty="false" Editable="false" HasMargin="false" Header="false" Height="2134" Protect="false" RowAddr="1" RowSpan="1" Width="10000">
			<xsl:attribute name="RowAddr"><xsl:value-of select="$RowAddr"/></xsl:attribute>
			<CELLMARGIN Bottom="100" Left="100" Right="100" Top="100"/>
			<PARALIST LineWrap="Break" LinkListID="0" LinkListIDNext="0" TextDirection="0" VertAlign="Center">
				<P ParaShape="32" Style="24">
					<TEXT CharShape="21"><CHAR><xsl:value-of select="$col_5"/></CHAR></TEXT>
				</P>
			</PARALIST>
		</CELL>
		<CELL BorderFill="4" ColAddr="5" ColSpan="1" Dirty="false" Editable="false" HasMargin="false" Header="false" Height="2134" Protect="false" RowAddr="1" RowSpan="1" Width="4000">
			<xsl:attribute name="RowAddr"><xsl:value-of select="$RowAddr"/></xsl:attribute>
			<CELLMARGIN Bottom="100" Left="100" Right="100" Top="100"/>
			<PARALIST LineWrap="Break" LinkListID="0" LinkListIDNext="0" TextDirection="0" VertAlign="Center">
				<P ParaShape="32" Style="24">
					<TEXT CharShape="21"><CHAR><xsl:value-of select="$col_6"/>㎨</CHAR></TEXT>
				</P>
			</PARALIST>
		</CELL>
	</ROW>

</xsl:template>



<xsl:template name="bitspan">
	<xsl:param name="bit"/>
	<xsl:param name="count"/>
	<!-- bitspan(<xsl:value-of select="$bit"/>, <xsl:value-of select="$count"/>) -->
	<xsl:if test="$count &gt; 0 and string-length(bit) &lt; 100">
		<!-- bitspan(<xsl:value-of select="$count"/>) -->
		<xsl:value-of select="$bit"/>
		<xsl:call-template name="bitspan">
			<xsl:with-param name="bit" select="$bit" />
			<xsl:with-param name="count" select="$count - 1" />
		</xsl:call-template>
	</xsl:if>
</xsl:template>


<xsl:template name="default_size">
	<xsl:param name="type"/>
	<xsl:choose>
		<xsl:when test="$type='int8_t'">bbbbbbbb</xsl:when>
		<xsl:when test="$type='int16_t'">bbbbbbbbbbbbbbbb</xsl:when>
		<xsl:when test="$type='int32_t'">bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb</xsl:when>
		<xsl:when test="$type='int64_t'">bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb</xsl:when>
		<xsl:when test="$type='u_int8_t'">bbbbbbbb</xsl:when>
		<xsl:when test="$type='u_int16_t'">bbbbbbbbbbbbbbbb</xsl:when>
		<xsl:when test="$type='u_int32_t'">bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb</xsl:when>
		<xsl:when test="$type='u_int64_t'">bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb</xsl:when>
		<xsl:when test="$type='scaled8_t'">bbbbbbbb</xsl:when>
		<xsl:when test="$type='scaled16_t'">bbbbbbbbbbbbbbbb</xsl:when>
		<xsl:when test="$type='scaled32_t'">bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb</xsl:when>
		<xsl:when test="$type='scaled64_t'">bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb</xsl:when>
		<xsl:when test="$type='u_scaled8_t'">bbbbbbbb</xsl:when>
		<xsl:when test="$type='u_scaled16_t'">bbbbbbbbbbbbbbbb</xsl:when>
		<xsl:when test="$type='u_scaled32_t'">bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb</xsl:when>
		<xsl:when test="$type='u_scaled64_t'">bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb</xsl:when>
		<xsl:when test="$type='enum8_t'">bbbbbbbb</xsl:when>
		<xsl:when test="$type='enum16_t'">bbbbbbbbbbbbbbbb</xsl:when>
		<xsl:when test="$type='enum32_t'">bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb</xsl:when>
		<xsl:when test="$type='enum64_t'">bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb</xsl:when>
		<xsl:when test="$type='ieee754_32_t'">bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb</xsl:when>
		<xsl:when test="$type='ieee754_64_t'">bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb</xsl:when>
		<xsl:when test="$type='ieee754_80_t'">bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb</xsl:when>
		<xsl:otherwise>(b)</xsl:otherwise>
	</xsl:choose>
</xsl:template>



<xsl:template name="bitsize_string">
	<xsl:param name="type"/>
	<xsl:param name="bitsize"/>
	<xsl:choose>
		<xsl:when test="$bitsize &gt; 0">
			<!-- " <xsl:value-of select="$bitsize"/> &gt; 0 " -->
			<xsl:call-template name="bitspan">
				<xsl:with-param name="bit" select="'b'" />
				<xsl:with-param name="count" select="$bitsize" />
			</xsl:call-template>
		</xsl:when>
		<xsl:otherwise>
			<xsl:call-template name="default_size">
				<xsl:with-param name="type" select="$type" />
			</xsl:call-template>
		</xsl:otherwise>
	</xsl:choose>
</xsl:template>



<xsl:template name="struct_size_string">
	<xsl:param name="data_domain_path"/>
	<xsl:param name="data"/>
	<xsl:for-each select="/nerv_system_interface/data_domains/data_domain[path=$data_domain_path]/datas/data[name=$data]">
		<!-- struct_size_string(<xsl:value-of select="$data_domain_path"/>, <xsl:value-of select="$data"/>) -->
		<xsl:choose>
			<xsl:when test="type='alias'">
				<xsl:call-template name="struct_size_string">
					<xsl:with-param name="data_domain_path" select="real_domain_path" />
					<xsl:with-param name="data" select="real_data" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="type='struct'">
				<xsl:for-each select="datafields/datafield">
					<xsl:variable name="member_size">
						<xsl:choose>
							<xsl:when test="type='alias' and bitsize=0">
								<xsl:call-template name="struct_size_string">
									<xsl:with-param name="data_domain_path" select="real_domain_path" />
									<xsl:with-param name="data" select="real_data" />
								</xsl:call-template>
							</xsl:when>
							<xsl:otherwise>
								<xsl:call-template name="bitsize_string">
									<xsl:with-param name="type" select="type" />
									<xsl:with-param name="bitsize" select="bitsize" />
								</xsl:call-template>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:variable>
					<!-- member(<xsl:value-of select="type"/>, <xsl:value-of select="$member_size"/>) -->
					<xsl:choose>
					<xsl:when test="arraytype='NO'">
						<xsl:value-of select="$member_size"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:call-template name="bitspan">
							<xsl:with-param name="bit" select="'$member_size'" />
							<xsl:with-param name="count" select="arraysize" />
						</xsl:call-template>
						<!-- bitspan-call(<xsl:value-of select="arraysize"/>) -->
					</xsl:otherwise>
					</xsl:choose>
				</xsl:for-each>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="bitsize_string">
					<xsl:with-param name="type" select="type" />
					<xsl:with-param name="bitsize" select="bitsize" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:for-each>
</xsl:template>


<xsl:template name="struct_size">
	<xsl:param name="data_domain_path"/>
	<xsl:param name="data"/>
	<xsl:variable name="struct_size_string">
		<xsl:call-template name="struct_size_string">
			<xsl:with-param name="data_domain_path" select="$data_domain_path" />
			<xsl:with-param name="data" select="$data" />
		</xsl:call-template>
	</xsl:variable>
	<!-- *<xsl:value-of select="$struct_size_string"/>* -->
	<xsl:value-of select="string-length($struct_size_string) div 8"/>
</xsl:template>

</xsl:stylesheet>
