<?xml version="1.0" encoding="utf-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="xml" encoding="utf-8" indent="yes"/>
<xsl:include href="chapter_3.2.5.3.1.xsl"/>

<xsl:template name="chapter_3.2.5.3">


<xsl:for-each select="/nerv_system_interface/system/nodes/node/processes/process/proxies/proxy">
	<xsl:variable name="proxy_component"><xsl:value-of select="../../../../name"/>::[<xsl:value-of select="../../name"/>]</xsl:variable>
	<xsl:variable name="proxy_name" select="name"/>
	<xsl:variable name="interface_path" select="interface_path"/>
	<xsl:variable name="interface" select="interface"/>
	<xsl:variable name="proxy_num" select="position()"/>
	<xsl:variable name="stub_component">
		<xsl:for-each select="/nerv_system_interface/system/nodes/node/processes/process/stubes/stub[name=$proxy_name]">
			<xsl:if test="position()=1"><xsl:value-of select="../../../../name"/>::[<xsl:value-of select="../../name"/>]</xsl:if>
		</xsl:for-each>
	</xsl:variable>
			<P/>
			<P InstId="" ParaShape="20" Style="3"><xsl:attribute name="InstId"><xsl:value-of select="generate-id()"/></xsl:attribute>
				<TEXT CharShape="8">
					<CHAR><xsl:value-of select="$proxy_component"/> <xsl:value-of select="name"/> 인터페이스</CHAR>
				</TEXT>
			</P>
			<P/>
			<P InstId="" ParaShape="33" Style="0"><xsl:attribute name="InstId"><xsl:value-of select="generate-id()"/></xsl:attribute>
				<TEXT CharShape="2">
					<CHAR>인터페이스 식별자 : <xsl:value-of select="name"/></CHAR>
				</TEXT>
			</P>
			<P InstId="" ParaShape="33" Style="0"><xsl:attribute name="InstId"><xsl:value-of select="generate-id()"/></xsl:attribute>
				<TEXT CharShape="2">
					<CHAR>사용 CSC : <xsl:value-of select="$proxy_component"/></CHAR>
				</TEXT>
			</P>
	<xsl:for-each select="/nerv_system_interface/system/nodes/node/processes/process/stubes/stub[name=$proxy_name]">
		<xsl:if test="position()=1">
			<P InstId="" ParaShape="33" Style="0"><xsl:attribute name="InstId"><xsl:value-of select="generate-id()"/></xsl:attribute>
				<TEXT CharShape="2">
					<CHAR>서비스 CSC : <xsl:value-of select="../../../../name"/>::[<xsl:value-of select="../../name"/>]</CHAR>
				</TEXT>
			</P>
		</xsl:if>
		<xsl:if test="position()>1">
			<P InstId="" ParaShape="33" Style="0"><xsl:attribute name="InstId"><xsl:value-of select="generate-id()"/></xsl:attribute>
				<TEXT CharShape="2">
					<CHAR>다중화 서비스 CSC 후보 <xsl:value-of select="position()-1"/> : <xsl:value-of select="../../../../name"/>::[<xsl:value-of select="../../name"/>]</CHAR>
				</TEXT>
			</P>
		</xsl:if>
	</xsl:for-each>
			<P ParaShape="30" Style="9">
				<TEXT CharShape="13">
					<TABLE BorderFill="4" CellSpacing="0" ColCount="4" PageBreak="Cell" RepeatHeader="true" RowCount="2">
					<xsl:attribute name="RowCount"><xsl:value-of select="count(/nerv_system_interface/method_domains/method_domain[path=$interface_path]/interfaces/interface[name=$interface]/membermethods/membermethod)+1"/></xsl:attribute>
						<SHAPEOBJECT InstId="" Lock="false" NumberingType="None" ZOrder="6"><xsl:attribute name="InstId"><xsl:value-of select="generate-id()"/></xsl:attribute>
							<SIZE Height="12270" HeightRelTo="Absolute" Protect="false" Width="46492" WidthRelTo="Absolute"/>
							<POSITION AffectLSpacing="false" AllowOverlap="false" FlowWithText="true" HoldAnchorAndSO="false" HorzAlign="Left" HorzOffset="0" HorzRelTo="Para" TreatAsChar="false" VertAlign="Top" VertOffset="0" VertRelTo="Para"/>
							<OUTSIDEMARGIN Bottom="283" Left="283" Right="283" Top="283"/>
						</SHAPEOBJECT>
						<INSIDEMARGIN Bottom="567" Left="850" Right="850" Top="567"/>
						<ROW>
							<CELL BorderFill="9" ColAddr="0" ColSpan="1" Dirty="false" Editable="false" HasMargin="false" Header="true" Height="2134" Protect="false" RowAddr="0" RowSpan="1" Width="15000">
								<CELLMARGIN Bottom="141" Left="510" Right="510" Top="141"/>
								<PARALIST LineWrap="Break" LinkListID="0" LinkListIDNext="0" TextDirection="0" VertAlign="Center">
									<P ParaShape="32" Style="23">
										<TEXT CharShape="20">
											<CHAR>세부 인터페이스 식별자</CHAR>
										</TEXT>
									</P>
									<P ParaShape="32" Style="23">
										<TEXT CharShape="20">
											<CHAR>세부 인터페이스 명</CHAR>
										</TEXT>
									</P>
								</PARALIST>
							</CELL>
							<CELL BorderFill="9" ColAddr="1" ColSpan="1" Dirty="false" Editable="false" HasMargin="false" Header="true" Height="2134" Protect="false" RowAddr="0" RowSpan="1" Width="10000">
								<CELLMARGIN Bottom="141" Left="510" Right="510" Top="141"/>
								<PARALIST LineWrap="Break" LinkListID="0" LinkListIDNext="0" TextDirection="0" VertAlign="Center">
									<P ParaShape="32" Style="23">
										<TEXT CharShape="20">
											<CHAR>전송방식</CHAR>
										</TEXT>
									</P>
									<P ParaShape="32" Style="23">
										<TEXT CharShape="20">
											<CHAR>식별코드</CHAR>
										</TEXT>
									</P>
								</PARALIST>
							</CELL>
							<CELL BorderFill="9" ColAddr="2" ColSpan="1" Dirty="false" Editable="false" HasMargin="false" Header="true" Height="2134" Protect="false" RowAddr="0" RowSpan="1" Width="15000">
								<CELLMARGIN Bottom="141" Left="510" Right="510" Top="141"/>
								<PARALIST LineWrap="Break" LinkListID="0" LinkListIDNext="0" TextDirection="0" VertAlign="Center">
									<P ParaShape="32" Style="23">
										<TEXT CharShape="20">
											<CHAR>연동 대상 자료</CHAR>
										</TEXT>
									</P>
								</PARALIST>
							</CELL>
							<CELL BorderFill="9" ColAddr="3" ColSpan="1" Dirty="false" Editable="false" HasMargin="false" Header="true" Height="2134" Protect="false" RowAddr="0" RowSpan="1" Width="6492">
								<CELLMARGIN Bottom="141" Left="510" Right="510" Top="141"/>
								<PARALIST LineWrap="Break" LinkListID="0" LinkListIDNext="0" TextDirection="0" VertAlign="Center">
									<P ParaShape="32" Style="23">
										<TEXT CharShape="20">
											<CHAR>관련항목</CHAR>
										</TEXT>
									</P>
								</PARALIST>
							</CELL>
						</ROW>
	<xsl:for-each select="/nerv_system_interface/method_domains/method_domain[path=$interface_path]/interfaces/interface[name=$interface]/membermethods/membermethod">
		<xsl:variable name="member_num" select="position()"/>
		<xsl:variable name="method_name" select="method_name"/>
		<xsl:for-each select="../../../../methods/method[name=$method_name]">
						<ROW>
							<CELL BorderFill="4" ColAddr="0" ColSpan="1" Dirty="false" Editable="false" HasMargin="false" Header="false" Height="1566" Protect="false" RowAddr="0" RowSpan="1" Width="15000">
								<xsl:attribute name="RowAddr"><xsl:value-of select="$member_num"/></xsl:attribute>
								<CELLMARGIN Bottom="141" Left="510" Right="510" Top="141"/>
								<PARALIST LineWrap="Break" LinkListID="0" LinkListIDNext="0" TextDirection="0" VertAlign="Center">
									<P ParaShape="32" Style="24">
										<TEXT CharShape="21">
											<CHAR><xsl:value-of select="name"/></CHAR>
										</TEXT>
									</P>
								</PARALIST>
							</CELL>
							<CELL BorderFill="4" ColAddr="1" ColSpan="1" Dirty="false" Editable="false" HasMargin="false" Header="false" Height="1566" Protect="false" RowAddr="0" RowSpan="1" Width="10000">
								<xsl:attribute name="RowAddr"><xsl:value-of select="$member_num"/></xsl:attribute>
								<CELLMARGIN Bottom="141" Left="510" Right="510" Top="141"/>
								<PARALIST LineWrap="Break" LinkListID="0" LinkListIDNext="0" TextDirection="0" VertAlign="Center">
									<P ParaShape="32" Style="24">
										<TEXT CharShape="21">
											<CHAR><xsl:value-of select="type"/></CHAR>
										</TEXT>
									</P>
									<P ParaShape="32" Style="24">
										<TEXT CharShape="21">
											<CHAR><xsl:value-of select="code"/></CHAR>
										</TEXT>
									</P>
								</PARALIST>
							</CELL>
							<CELL BorderFill="4" ColAddr="2" ColSpan="1" Dirty="false" Editable="false" HasMargin="false" Header="false" Height="1566" Protect="false" RowAddr="0" RowSpan="1" Width="15000">
								<xsl:attribute name="RowAddr"><xsl:value-of select="$member_num"/></xsl:attribute>
								<CELLMARGIN Bottom="141" Left="510" Right="510" Top="141"/>
								<PARALIST LineWrap="Break" LinkListID="0" LinkListIDNext="0" TextDirection="0" VertAlign="Center">
									<P ParaShape="0" Style="0">
										<TEXT CharShape="21">
											<CHAR>입력 : <xsl:value-of select="in_data"/></CHAR>
										</TEXT>
									</P>
									<P ParaShape="0" Style="0">
										<TEXT CharShape="21">
											<CHAR>출력 : <xsl:value-of select="out_data"/></CHAR>
										</TEXT>
									</P>
								</PARALIST>
							</CELL>
							<CELL BorderFill="4" ColAddr="3" ColSpan="1" Dirty="false" Editable="false" HasMargin="false" Header="false" Height="1566" Protect="false" RowAddr="0" RowSpan="1" Width="6492">
								<xsl:attribute name="RowAddr"><xsl:value-of select="$member_num"/></xsl:attribute>
								<CELLMARGIN Bottom="141" Left="510" Right="510" Top="141"/>
								<PARALIST LineWrap="Break" LinkListID="0" LinkListIDNext="0" TextDirection="0" VertAlign="Center">
									<P ParaShape="32" Style="24">
										<TEXT CharShape="21">
											<CHAR>3.1.2.<xsl:value-of select="$proxy_num+2"/>.<xsl:value-of select="$member_num"/></CHAR>
										</TEXT>
									</P>
								</PARALIST>
							</CELL>
						</ROW>
		</xsl:for-each>
	</xsl:for-each>
					</TABLE>
					<CHAR/>
				</TEXT>
			</P>


	<xsl:call-template name="chapter_3.2.5.3.1">
		<xsl:with-param name="interface_path" select="$interface_path" />
		<xsl:with-param name="interface" select="$interface" />
		<xsl:with-param name="proxy_component" select="$proxy_component" />
		<xsl:with-param name="stub_component" select="$stub_component" />
	</xsl:call-template>



</xsl:for-each>






<xsl:for-each select="/nerv_system_interface/system/nodes/node/processes/process/stubes/stub">
	<xsl:variable name="stub_component"><xsl:value-of select="../../../../name"/>::[<xsl:value-of select="../../name"/>]</xsl:variable>
	<xsl:variable name="stub_name" select="name"/>
	<xsl:variable name="interface_path" select="interface_path"/>
	<xsl:variable name="interface" select="interface"/>
	<xsl:variable name="stub_num" select="position()"/>
	<xsl:variable name="proxy_component">
		<xsl:for-each select="/nerv_system_interface/system/nodes/node/processes/process/stubes/stub[name=$stub_name]">
			<xsl:if test="position()=1"><xsl:value-of select="../../../../name"/>::[<xsl:value-of select="../../name"/>]</xsl:if>
		</xsl:for-each>
	</xsl:variable>
			<P/>
			<P InstId="" ParaShape="20" Style="3"><xsl:attribute name="InstId"><xsl:value-of select="generate-id()"/></xsl:attribute>
				<TEXT CharShape="8">
					<CHAR><xsl:value-of select="$stub_component"/> <xsl:value-of select="name"/> 인터페이스</CHAR>
				</TEXT>
			</P>
			<P/>
			<P InstId="" ParaShape="33" Style="0"><xsl:attribute name="InstId"><xsl:value-of select="generate-id()"/></xsl:attribute>
				<TEXT CharShape="2">
					<CHAR>인터페이스 식별자 : <xsl:value-of select="name"/></CHAR>
				</TEXT>
			</P>
			<P InstId="" ParaShape="33" Style="0"><xsl:attribute name="InstId"><xsl:value-of select="generate-id()"/></xsl:attribute>
				<TEXT CharShape="2">
					<CHAR>사용 CSC : <xsl:value-of select="$stub_component"/></CHAR>
				</TEXT>
			</P>
	<xsl:for-each select="/nerv_system_interface/system/nodes/node/processes/process/stubes/stub[name=$stub_name]">
		<xsl:if test="position()=1">
			<P InstId="" ParaShape="33" Style="0"><xsl:attribute name="InstId"><xsl:value-of select="generate-id()"/></xsl:attribute>
				<TEXT CharShape="2">
					<CHAR>서비스 CSC : <xsl:value-of select="../../../../name"/>::[<xsl:value-of select="../../name"/>]</CHAR>
				</TEXT>
			</P>
		</xsl:if>
		<xsl:if test="position()>1">
			<P InstId="" ParaShape="33" Style="0"><xsl:attribute name="InstId"><xsl:value-of select="generate-id()"/></xsl:attribute>
				<TEXT CharShape="2">
					<CHAR>다중화 서비스 CSC 후보 <xsl:value-of select="position()-1"/> : <xsl:value-of select="../../../../name"/>::[<xsl:value-of select="../../name"/>]</CHAR>
				</TEXT>
			</P>
		</xsl:if>
	</xsl:for-each>
			<P ParaShape="30" Style="9">
				<TEXT CharShape="13">
					<TABLE BorderFill="4" CellSpacing="0" ColCount="4" PageBreak="Cell" RepeatHeader="true" RowCount="2">
					<xsl:attribute name="RowCount"><xsl:value-of select="count(/nerv_system_interface/method_domains/method_domain[path=$interface_path]/interfaces/interface[name=$interface]/membermethods/membermethod)+1"/></xsl:attribute>
						<SHAPEOBJECT InstId="" Lock="false" NumberingType="None" ZOrder="6"><xsl:attribute name="InstId"><xsl:value-of select="generate-id()"/></xsl:attribute>
							<SIZE Height="12270" HeightRelTo="Absolute" Protect="false" Width="46492" WidthRelTo="Absolute"/>
							<POSITION AffectLSpacing="false" AllowOverlap="false" FlowWithText="true" HoldAnchorAndSO="false" HorzAlign="Left" HorzOffset="0" HorzRelTo="Para" TreatAsChar="false" VertAlign="Top" VertOffset="0" VertRelTo="Para"/>
							<OUTSIDEMARGIN Bottom="283" Left="283" Right="283" Top="283"/>
						</SHAPEOBJECT>
						<INSIDEMARGIN Bottom="567" Left="850" Right="850" Top="567"/>
						<ROW>
							<CELL BorderFill="9" ColAddr="0" ColSpan="1" Dirty="false" Editable="false" HasMargin="false" Header="true" Height="2134" Protect="false" RowAddr="0" RowSpan="1" Width="15000">
								<CELLMARGIN Bottom="141" Left="510" Right="510" Top="141"/>
								<PARALIST LineWrap="Break" LinkListID="0" LinkListIDNext="0" TextDirection="0" VertAlign="Center">
									<P ParaShape="32" Style="23">
										<TEXT CharShape="20">
											<CHAR>세부 인터페이스 식별자</CHAR>
										</TEXT>
									</P>
									<P ParaShape="32" Style="23">
										<TEXT CharShape="20">
											<CHAR>세부 인터페이스 명</CHAR>
										</TEXT>
									</P>
								</PARALIST>
							</CELL>
							<CELL BorderFill="9" ColAddr="1" ColSpan="1" Dirty="false" Editable="false" HasMargin="false" Header="true" Height="2134" Protect="false" RowAddr="0" RowSpan="1" Width="10000">
								<CELLMARGIN Bottom="141" Left="510" Right="510" Top="141"/>
								<PARALIST LineWrap="Break" LinkListID="0" LinkListIDNext="0" TextDirection="0" VertAlign="Center">
									<P ParaShape="32" Style="23">
										<TEXT CharShape="20">
											<CHAR>전송방식</CHAR>
										</TEXT>
									</P>
									<P ParaShape="32" Style="23">
										<TEXT CharShape="20">
											<CHAR>식별코드</CHAR>
										</TEXT>
									</P>
								</PARALIST>
							</CELL>
							<CELL BorderFill="9" ColAddr="2" ColSpan="1" Dirty="false" Editable="false" HasMargin="false" Header="true" Height="2134" Protect="false" RowAddr="0" RowSpan="1" Width="15000">
								<CELLMARGIN Bottom="141" Left="510" Right="510" Top="141"/>
								<PARALIST LineWrap="Break" LinkListID="0" LinkListIDNext="0" TextDirection="0" VertAlign="Center">
									<P ParaShape="32" Style="23">
										<TEXT CharShape="20">
											<CHAR>연동 대상 자료</CHAR>
										</TEXT>
									</P>
								</PARALIST>
							</CELL>
							<CELL BorderFill="9" ColAddr="3" ColSpan="1" Dirty="false" Editable="false" HasMargin="false" Header="true" Height="2134" Protect="false" RowAddr="0" RowSpan="1" Width="6492">
								<CELLMARGIN Bottom="141" Left="510" Right="510" Top="141"/>
								<PARALIST LineWrap="Break" LinkListID="0" LinkListIDNext="0" TextDirection="0" VertAlign="Center">
									<P ParaShape="32" Style="23">
										<TEXT CharShape="20">
											<CHAR>관련항목</CHAR>
										</TEXT>
									</P>
								</PARALIST>
							</CELL>
						</ROW>
	<xsl:for-each select="/nerv_system_interface/method_domains/method_domain[path=$interface_path]/interfaces/interface[name=$interface]/membermethods/membermethod">
		<xsl:variable name="member_num" select="position()"/>
		<xsl:variable name="method_name" select="method_name"/>
		<xsl:for-each select="../../../../methods/method[name=$method_name]">
						<ROW>
							<CELL BorderFill="4" ColAddr="0" ColSpan="1" Dirty="false" Editable="false" HasMargin="false" Header="false" Height="1566" Protect="false" RowAddr="0" RowSpan="1" Width="15000">
								<xsl:attribute name="RowAddr"><xsl:value-of select="$member_num"/></xsl:attribute>
								<CELLMARGIN Bottom="141" Left="510" Right="510" Top="141"/>
								<PARALIST LineWrap="Break" LinkListID="0" LinkListIDNext="0" TextDirection="0" VertAlign="Center">
									<P ParaShape="32" Style="24">
										<TEXT CharShape="21">
											<CHAR><xsl:value-of select="name"/></CHAR>
										</TEXT>
									</P>
								</PARALIST>
							</CELL>
							<CELL BorderFill="4" ColAddr="1" ColSpan="1" Dirty="false" Editable="false" HasMargin="false" Header="false" Height="1566" Protect="false" RowAddr="0" RowSpan="1" Width="10000">
								<xsl:attribute name="RowAddr"><xsl:value-of select="$member_num"/></xsl:attribute>
								<CELLMARGIN Bottom="141" Left="510" Right="510" Top="141"/>
								<PARALIST LineWrap="Break" LinkListID="0" LinkListIDNext="0" TextDirection="0" VertAlign="Center">
									<P ParaShape="32" Style="24">
										<TEXT CharShape="21">
											<CHAR><xsl:value-of select="type"/></CHAR>
										</TEXT>
									</P>
									<P ParaShape="32" Style="24">
										<TEXT CharShape="21">
											<CHAR><xsl:value-of select="code"/></CHAR>
										</TEXT>
									</P>
								</PARALIST>
							</CELL>
							<CELL BorderFill="4" ColAddr="2" ColSpan="1" Dirty="false" Editable="false" HasMargin="false" Header="false" Height="1566" Protect="false" RowAddr="0" RowSpan="1" Width="15000">
								<xsl:attribute name="RowAddr"><xsl:value-of select="$member_num"/></xsl:attribute>
								<CELLMARGIN Bottom="141" Left="510" Right="510" Top="141"/>
								<PARALIST LineWrap="Break" LinkListID="0" LinkListIDNext="0" TextDirection="0" VertAlign="Center">
									<P ParaShape="0" Style="0">
										<TEXT CharShape="21">
											<CHAR>입력 : <xsl:value-of select="in_data"/></CHAR>
										</TEXT>
									</P>
									<P ParaShape="0" Style="0">
										<TEXT CharShape="21">
											<CHAR>출력 : <xsl:value-of select="out_data"/></CHAR>
										</TEXT>
									</P>
								</PARALIST>
							</CELL>
							<CELL BorderFill="4" ColAddr="3" ColSpan="1" Dirty="false" Editable="false" HasMargin="false" Header="false" Height="1566" Protect="false" RowAddr="0" RowSpan="1" Width="6492">
								<xsl:attribute name="RowAddr"><xsl:value-of select="$member_num"/></xsl:attribute>
								<CELLMARGIN Bottom="141" Left="510" Right="510" Top="141"/>
								<PARALIST LineWrap="Break" LinkListID="0" LinkListIDNext="0" TextDirection="0" VertAlign="Center">
									<P ParaShape="32" Style="24">
										<TEXT CharShape="21">
											<CHAR>3.1.2.<xsl:value-of select="$stub_num+2"/>.<xsl:value-of select="$member_num"/></CHAR>
										</TEXT>
									</P>
								</PARALIST>
							</CELL>
						</ROW>
		</xsl:for-each>
	</xsl:for-each>
					</TABLE>
					<CHAR/>
				</TEXT>
			</P>


	<xsl:call-template name="chapter_3.2.5.3.1">
		<xsl:with-param name="interface_path" select="$interface_path" />
		<xsl:with-param name="interface" select="$interface" />
		<xsl:with-param name="stub_component" select="$stub_component" />
		<xsl:with-param name="proxy_component" select="$proxy_component" />
	</xsl:call-template>



</xsl:for-each>




</xsl:template>
</xsl:stylesheet>
