<?xml version="1.0" encoding="utf-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="text" encoding="utf-8" indent="yes"/>
<xsl:include href="../../xsl_util.xsl"/>


<xsl:template match="/">

```plantuml
@startuml

<!-- scale max 2048 width -->

!include &lt;office/Servers/application_server&gt;
!include &lt;office/Devices/switch&gt;

nwdiag {

<xsl:for-each select="/nerv_system_interface/system/ports/port">
    group {
        color = "#7777FF";
        J_<xsl:value-of select="number"/>;
    }
</xsl:for-each>

<xsl:for-each select="/nerv_system_interface/system/links/link">
    <xsl:variable name="s_node_name" select="s_node_name"/>
    <xsl:variable name="d_node_name" select="d_node_name"/>

    <xsl:if test="s_node_id=0 or d_node_id=0">
        <xsl:variable name="s_link_name">
            <xsl:call-template name="remove_spechar">
                <xsl:with-param name="text" select="$s_node_name"/>
            </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="d_link_name">
            <xsl:call-template name="remove_spechar">
                <xsl:with-param name="text" select="$d_node_name"/>
            </xsl:call-template>
        </xsl:variable>
        <xsl:if test="s_node_id=0"><xsl:text>
    </xsl:text>network {
        J_<xsl:value-of select="s_port_id"/>;
        <xsl:value-of select="$d_link_name"/>;
    }
        </xsl:if>
        <xsl:if test="d_node_id=0"><xsl:text>
    </xsl:text>network {
        <xsl:value-of select="$s_link_name"/>;
        J_<xsl:value-of select="d_port_id"/>;
    }
        </xsl:if>
    </xsl:if>
    <xsl:for-each select="/nerv_system_interface/system/nodes/node[name=$s_node_name and type!='switch']">
        <xsl:variable name="s_node_type" select="type"/>
        <xsl:for-each select="/nerv_system_interface/system/nodes/node[name=$d_node_name and type!='switch']">
            <xsl:variable name="d_node_type" select="type"/>
            <xsl:if test="($s_node_type='switch' and $d_node_type='switch') or ($s_node_type!='switch' and $d_node_type!='switch')">
                <xsl:variable name="s_link_name">
                    <xsl:call-template name="remove_spechar">
                        <xsl:with-param name="text" select="$s_node_name"/>
                    </xsl:call-template>
                </xsl:variable>
                <xsl:variable name="d_link_name">
                    <xsl:call-template name="remove_spechar">
                        <xsl:with-param name="text" select="$d_node_name"/>
                    </xsl:call-template>
                </xsl:variable>
                <xsl:if test="$s_node_type='switch' and $d_node_type='switch'"><xsl:text>
    </xsl:text>network {
        <xsl:value-of select="$s_link_name"/>[description = "&lt;$switch&gt;"];
        <xsl:value-of select="$d_link_name"/>[description = "&lt;$switch&gt;"];
    }
                </xsl:if>
                <xsl:if test="$s_node_type!='switch' and $d_node_type!='switch'"><xsl:text>
    </xsl:text>network {
        <xsl:value-of select="$s_link_name"/>;
        <xsl:value-of select="$d_link_name"/>;
    }
                </xsl:if>
            </xsl:if>
        </xsl:for-each>
    </xsl:for-each>
</xsl:for-each>

<xsl:for-each select="/nerv_system_interface/system/nodes/node[type='switch']">

    <xsl:variable name="switch_name">
        <xsl:call-template name="remove_spechar">
            <xsl:with-param name="text" select="name"/>
        </xsl:call-template>
    </xsl:variable>

    <xsl:variable name="node_name" select="name"/>

    network <xsl:value-of select="$switch_name"/> {
        color = "green"

        <xsl:value-of select="$switch_name"/>[description = "&lt;$switch&gt;\n <xsl:value-of select="$switch_name"/>"];

    <xsl:for-each select="/nerv_system_interface/system/links/link[s_node_name=$node_name and d_node_id != 0]">
        <xsl:variable name="link_name">
            <xsl:call-template name="remove_spechar">
                <xsl:with-param name="text" select="d_node_name"/>
            </xsl:call-template>
        </xsl:variable>
        <xsl:value-of select="$link_name"/>;
    </xsl:for-each>


    <xsl:for-each select="/nerv_system_interface/system/links/link[d_node_name=$node_name and s_node_id != 0]">
        <xsl:variable name="link_name">
            <xsl:call-template name="remove_spechar">
                <xsl:with-param name="text" select="s_node_name"/>
            </xsl:call-template>
        </xsl:variable>
        <xsl:value-of select="$link_name"/>;
    </xsl:for-each>


    }
</xsl:for-each>

    <!-- network export {
        color = "#7777FF";
<xsl:for-each select="/nerv_system_interface/system/ports/port">
        J_<xsl:value-of select="number"/>;
</xsl:for-each>
    } -->

}
@enduml
```
</xsl:template>


</xsl:stylesheet>
