<?xml version="1.0" encoding="utf-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="text" encoding="utf-8" indent="yes"/>
<xsl:include href="../xsl_util.xsl"/>
<xsl:template match="/">#!/bin/bash

# 배치 다이어그램 만들기
xalan -o $1.artifact/deployment_uml.md $1 /usr/local/share/Nerv/Nerv36/XSL/HML/UML/deployment_uml.xsl
java -jar /usr/bin/plantuml.jar -charset UTF-8 $1.artifact/deployment_uml.md

# 시스템 인터페이스 다이어그램 만들기
xalan -o $1.artifact/system_interface_uml.md $1 /usr/local/share/Nerv/Nerv36/XSL/HML/UML/system_interface_uml.xsl
java -jar /usr/bin/plantuml.jar -charset UTF-8 $1.artifact/system_interface_uml.md

<xsl:for-each select="/nerv_system_interface/system/nodes/node/processes/process/stubes/stub">
# <xsl:value-of select="name"/> 인터페이스 다이어그램 만들기
xalan -o $1.artifact/<xsl:value-of select="name"/>_interface_uml.md -p stub_name "'<xsl:value-of select="name"/>'"   $1 /usr/local/share/Nerv/Nerv36/XSL/HML/UML/interface_uml.xsl
java -jar /usr/bin/plantuml.jar -charset UTF-8 $1.artifact/<xsl:value-of select="name"/>_interface_uml.md
</xsl:for-each>

# 네트워크 다이어그램 만들기
xalan -o $1.artifact/network_uml.md $1 /usr/local/share/Nerv/Nerv36/XSL/HML/UML/network_uml.xsl
java -jar /usr/bin/plantuml.jar -charset UTF-8 $1.artifact/network_uml.md

# HML 파일 만들기
xalan -o $1.artifact/IDD.hml $1 /usr/local/share/Nerv/Nerv36/XSL/HML/IDD/IDD.xsl

<!-- rm $1.artifact/*.md -->

</xsl:template>
</xsl:stylesheet>
