<?xml version="1.0" encoding="utf-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:include href="../xsl_util.xsl"/>
<xsl:output method="text" encoding="utf-8" indent="yes" />
<xsl:param name = "export_stub_class_id" />
<xsl:template match="/">
import time
import threading
import signal
import sys
import py_nerv36 as nerv
from py_nerv36 import Data as nstt # Nerv struct
import py_nerv36_print_data as nprint
import py_nerv36_set_data as nset

  <xsl:for-each select="/nerv_icde/component/stub_list/row[id=$export_stub_class_id]">
    <xsl:variable name="method_domain_id" select="method_domain_id" />
    <xsl:variable name="interface_name" select="interface_name" />
    <xsl:variable name="class_name" select="class_name" />
class <xsl:value-of select="class_name"/>(nerv.<xsl:value-of select="class_name"/>):


    def __init__(self):
        super().__init__()
        self.proxy_addr = nerv.Address()
        self.proxy_addr.ip = 0
        self.proxy_addr.port = 0
        pass

    def on_connect(self, _proxy_addr):
        self.proxy_addr = _proxy_addr
        print("<xsl:value-of select="$class_name"/>::on_connect()")
        print(flush=True)
        pass

    def on_disconnect(self, _proxy_addr):
        print("<xsl:value-of select="$class_name"/>::on_disconnect()")
        print(flush=True)
        pass

    <xsl:for-each select="/nerv_icde/methoddomain/row[id=$method_domain_id]">
      <xsl:for-each select="interface/row[name=$interface_name]">
        <xsl:for-each select="membermethod/row">
          <xsl:variable name="method_name" select="method_name" />
          <xsl:for-each select="../../../../method/row[name=$method_name]">
            <xsl:choose>


              <xsl:when test="type='CALLBACK'">
                <xsl:choose >
                  <xsl:when test="in_data='(null)'">
    def on_<xsl:value-of select="$method_name"/>_return(self, _msg_num, _err, _elapsed ):
        print("<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_return(%d,%s,%lf)" % ( _msg_num, nerv.get_err_str(_err), _elapsed) )
        print(flush=True)
        pass
                  </xsl:when>
                  <xsl:otherwise>
    def on_<xsl:value-of select="$method_name"/>_return(self, _msg_num, _err, _ret_dat_, _elapsed ):
        print("<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_return(%d,%s,%lf)" % ( _msg_num, nerv.get_err_str(_err), _elapsed) )
        nprint.<xsl:value-of select="in_data_domain"/>_<xsl:value-of select="in_data"/>(_ret_dat_)
        print(flush=True)
        pass
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:when>
              <xsl:when test="type='SIGNALBACK'">
    def on_<xsl:value-of select="$method_name"/>_return(self, _msg_num, _err, _elapsed ):
        print("<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_return(%d,%s,%lf)" % ( _msg_num, nerv.get_err_str(_err), _elapsed) )
        print(flush=True)
        pass
              </xsl:when>


              <xsl:when test="type='CALL'">
                <xsl:choose>
                  <xsl:when test="in_data='(null)' and out_data='(null)'">
    def on_<xsl:value-of select="$method_name"/>(self, _proxy_addr, _elapsed, _limit):
        print("<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>()")
        print(flush=True)
        return 0
                  </xsl:when>
                  <xsl:when test="in_data='(null)' and out_data!='(null)'">
    def on_<xsl:value-of select="$method_name"/>(self, _proxy_addr, _ret_dat_, _elapsed, _limit):
        print("<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>()")
        print(flush=True)
        nset.<xsl:value-of select="out_data_domain"/>_<xsl:value-of select="out_data"/>(_ret_dat_, 0)
        return 0
                  </xsl:when>
                  <xsl:when test="in_data!='(null)' and out_data='(null)'">
    def on_<xsl:value-of select="$method_name"/>(self, _proxy_addr, _cal_dat_, _elapsed, _limit):
        print("<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>()")
        nprint.<xsl:value-of select="in_data_domain"/>_<xsl:value-of select="in_data"/>(_cal_dat_)
        print(flush=True)
        return 0
                  </xsl:when>
                  <xsl:when test="in_data!='(null)' and out_data!='(null)'">
    def on_<xsl:value-of select="$method_name"/>(self, _proxy_addr, _cal_dat_, _ret_dat_, _elapsed, _limit):
        print("<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>()")
        nprint.<xsl:value-of select="in_data_domain"/>_<xsl:value-of select="in_data"/>(_cal_dat_)
        print(flush=True)
        nset.<xsl:value-of select="out_data_domain"/>_<xsl:value-of select="out_data"/>(_ret_dat_, 0 )
        return 0
                  </xsl:when>
                </xsl:choose>
    def on_<xsl:value-of select="$method_name"/>_cancel(self, _proxy_addr, _err):
        print("<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_cancel()")
        print(flush=True)
        return 0
              </xsl:when>

              <xsl:when test="type='SIGNAL'">
                <xsl:choose >
                  <xsl:when test="in_data='(null)'">
    def on_<xsl:value-of select="$method_name"/>(self, _proxy_addr, _elapsed):
        print("<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>()")
        print(flush=True)
        return 0
                  </xsl:when>
                  <xsl:otherwise>
    def on_<xsl:value-of select="$method_name"/>(self, _proxy_addr, _sig_data_, _elapsed):
        print("<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>()")
        nprint.<xsl:value-of select="in_data_domain"/>_<xsl:value-of select="in_data"/>(_sig_data_)
        print(flush=True)
        return 0
                  </xsl:otherwise>
                </xsl:choose >
    def on_<xsl:value-of select="$method_name"/>_cancel(self, _proxy_addr, in_error):
        print("<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_cancel()")
        print(flush=True)
        pass
              </xsl:when>

              <xsl:when test="type='EVENT'">
    def on_<xsl:value-of select="$method_name"/>_link(self, _proxy_addr, _elapsed, _limit):
        print("<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_link()")
        print(flush=True)
        return 0
    def on_<xsl:value-of select="$method_name"/>_unlink(self, _proxy_addr, err):
        print("<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_unlink()")
        print(flush=True)
        pass
              </xsl:when>

              <xsl:when test="type='COMMAND'">
    def on_<xsl:value-of select="$method_name"/>_link(self, _proxy_addr, _elapsed, _limit):
        print("<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_link()")
        print(flush=True)
        return 0
    def on_<xsl:value-of select="$method_name"/>_unlink(self, _proxy_addr, err ):
        print("<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_unlink()")
        print(flush=True)
        pass
                <xsl:choose >
                  <xsl:when test="in_data='(null)'">
    def on_<xsl:value-of select="$method_name"/>_sync(self, _proxy_addr, _sync_model, _elapsed, _limit):
        print("<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_sync()")
        print(flush=True)
        pass
                  </xsl:when>
                  <xsl:otherwise>
    def on_<xsl:value-of select="$method_name"/>_sync(self, _proxy_addr, _sync_model, _elapsed, _limit, _cmd_dat_):
        print("<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_sync()")
        nprint.<xsl:value-of select="in_data_domain"/>_<xsl:value-of select="in_data"/>(_cmd_dat_)
        print(flush=True)
        pass
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:when>

              <xsl:when test="type='INFORMATION'">
    def on_<xsl:value-of select="$method_name"/>_link(self, _proxy_addr, _tcp_request, _elapsed, _limit):
        print("<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_link()")
        print(flush=True)
        return 0
    def on_<xsl:value-of select="$method_name"/>_unlink(self, _proxy_addr, _err ):
        print("<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_unlink()")
        print(flush=True)
        pass
              </xsl:when>
            </xsl:choose>
          </xsl:for-each>
        </xsl:for-each>
      </xsl:for-each>
    </xsl:for-each>
  </xsl:for-each>


</xsl:template>


</xsl:stylesheet>
