#pragma once


#include <Waregram/_debug.hpp>
#include <string>


#if defined __GNUC__ && defined __linux__
	#include <unistd.h>
	// #include <sys/socket.h>
	// #include <netinet/in.h>
    #include <netinet/tcp.h>
	#include <arpa/inet.h>

	typedef int Socket;
    typedef sa_family_t Sa_family;
    typedef socklen_t Socklen;

	#define INVALID_SOCKET (Socket)(-1)

	static inline int closesocket(Socket sock)
	{
		NOTRACE("closesocket %x", sock);
		return close(sock);
	}

	#define SOCKET_ERROR (int)(-1)

#elif defined _MSC_VER
	#include <winsock2.h>
	typedef SOCKET Socket;
    typedef ADDRESS_FAMILY Sa_family;
    typedef int Socklen;
#endif

static std::string str_from_ip(uint32_t _ip)
{
	char buf[128];

	snprintf(buf, sizeof(buf),"%u.%u.%u.%u", ((0x000000FFU & _ip) >> 0U),
	        ((0x0000FF00U & _ip) >> 8U), ((0x00FF0000U & _ip) >> 16U),
	        ((0xFF000000U & _ip) >> 24U));

	return buf;
}

static const unsigned long inet_addr(const unsigned char& s_b1,
                                     const unsigned char& s_b2,
                                     const unsigned char& s_b3,
                                     const unsigned char& s_b4)
{
	return ((unsigned long)(s_b1) << 0U) | ((unsigned long)(s_b2) << 8U) |
	       ((unsigned long)(s_b3) << 16U) | ((unsigned long)(s_b4) << 24U);
}

static int wg_inet_initialize()
{
	int ret_err = 0;
#if defined _MSC_VER
	WSADATA wsaData;
	if(WSAStartup(MAKEWORD(2, 2), &wsaData)) { ret_err = -1; }
#endif
	return ret_err;
}

// Inet destroy
static void wg_inet_destroy()
{
#if defined _MSC_VER
	WSACleanup();
#endif
}

#if defined __GNUC__ && defined __linux__
#include <algorithm>
#include <errno.h>
#include <fcntl.h>
#include <stdio.h>
#include <unistd.h>

static int fflag_on(int fd, int _flag)
{
	int ret_err;
	try {
		int get_flags;

		get_flags = fcntl(fd, F_GETFL);
		if(get_flags == -1) throw - 1;

		int set_flags = (unsigned int)get_flags | (unsigned int)_flag;

		ret_err = fcntl(fd, F_SETFL, set_flags);
	}
	catch(int const catch_err) {
		ret_err = catch_err;
	}
	return ret_err;
}

static int fflag_off(int fd, int _flag)
{
	int ret_err;
	try {
		int get_flags;
		get_flags = fcntl(fd, F_GETFL);
		if(get_flags == -1) throw - 1;

		int set_flags = (unsigned int)get_flags & ~(unsigned int)_flag;

		ret_err = fcntl(fd, F_SETFL, set_flags);
	}
	catch(int const catch_err) {
		ret_err = catch_err;
	}
	return ret_err;
}
#endif
