<?xml version="1.0" encoding="utf-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:include href="../../../../../xsl_util.xsl"/>

<xsl:output method="text" encoding="utf-8" indent="yes"/>

<xsl:param name = "export_proxy_class_id" />

<xsl:template match="/">
  <xsl:for-each select="/nerv_icde/component/proxy_list/row[id=$export_proxy_class_id]">
    <xsl:variable name="method_domain_id" select="method_domain_id" />
    <xsl:variable name="interface_name" select="interface_name" />
    <xsl:variable name="class_name" select="class_name" />

#include "<xsl:value-of select="$class_name"/>.h"

<xsl:value-of select="$class_name"/>::<xsl:value-of select="$class_name"/>()
{
}

<xsl:value-of select="$class_name"/>::~<xsl:value-of select="$class_name"/>()
{
}

Nerv36::Error <xsl:value-of select="$class_name"/>::start( const char* _url_ )
{
    Nerv36::Error ret;
    Py_BEGIN_ALLOW_THREADS
    ret = Nerv36::Proxy::start( _url_);
    Py_END_ALLOW_THREADS
    return ret;
}

Nerv36::Error <xsl:value-of select="$class_name"/>::stop()
{
    Nerv36::Error ret;
    Py_BEGIN_ALLOW_THREADS
    ret = Nerv36::Proxy::stop();
    Py_END_ALLOW_THREADS
    return ret;
}

Nerv36::Error <xsl:value-of select="$class_name"/>::py_get_address(Nerv36::Address&amp; _proxy_addr_, Nerv36::Address&amp; _stub_addr_)
{
    return Proxy::get_address(&amp;_proxy_addr_, &amp;_stub_addr_);
}

void <xsl:value-of select="$class_name"/>::on_connect()
{
    PyGILState_STATE state = PyGILState_Ensure();
    this->get_override("on_connect")();
    PyGILState_Release(state);
}

void <xsl:value-of select="$class_name"/>::on_disconnect()
{
    PyGILState_STATE state = PyGILState_Ensure();
    this->get_override("on_disconnect")();
    PyGILState_Release(state);
}

    <xsl:for-each select="/nerv_icde/methoddomain/row[id=$method_domain_id]">
      <xsl:for-each select="interface/row[name=$interface_name]">
        <xsl:for-each select="membermethod/row">
          <xsl:variable name="method_name" select="method_name" />
          <xsl:for-each select="../../../../method/row[name=$method_name]">

            <xsl:variable name="in_data_domain_namespace">
              <xsl:call-template name="get_data_domain_namespace">
                <xsl:with-param name="data_domain_id" select="in_data_domain_id" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="out_data_domain_namespace">
              <xsl:call-template name="get_data_domain_namespace">
                <xsl:with-param name="data_domain_id" select="out_data_domain_id" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="type='CALLBACK'">
::Nerv36::Error <xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>( <xsl:if test="out_data!='(null)'">const Nerv36::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>* _clb_dat_, </xsl:if><xsl:if test="in_data!='(null)'">Nerv36::Data<xsl:value-of select="$in_data_domain_namespace"/>::<xsl:value-of select="in_data"/>* _ret_dat_, </xsl:if> double _elapsed, double _limit)
{
    PyGILState_STATE state = PyGILState_Ensure();
    Nerv36::Error ret_err = this->get_override("on_<xsl:value-of select="$method_name"/>")(  <xsl:if test="out_data!='(null)'">_clb_dat_  ,</xsl:if><xsl:if test="in_data!='(null)'">_ret_dat_,</xsl:if> _elapsed, _limit);
    PyGILState_Release(state);
    return 0;
}
void <xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_cancel( ::Nerv36::Error _err)
{
    PyGILState_STATE state = PyGILState_Ensure();
    this->get_override("on_<xsl:value-of select="$method_name"/>_cancel")(_err);
    PyGILState_Release(state);
}
              </xsl:when>
              <xsl:when test="type='SIGNALBACK'">
void <xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>( <xsl:if test="out_data!='(null)'">const ::Nerv36::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>* _sgb_dat_,</xsl:if> double _elapsed)
{
    PyGILState_STATE state = PyGILState_Ensure();
    this->get_override("on_<xsl:value-of select="$method_name"/>")(<xsl:if test="out_data!='(null)'">_sgb_dat_,</xsl:if> _elapsed);
    PyGILState_Release(state);
}
void <xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_cancel( ::Nerv36::Error _err)
{
    PyGILState_STATE state = PyGILState_Ensure();
    this->get_override("on_<xsl:value-of select="$method_name"/>_cancel")(_err);
    PyGILState_Release(state);
}
              </xsl:when>
              <xsl:when test="type='CALL'">
void <xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_return(Nerv36::Msg_num _msg_num, Nerv36::Error _err,<xsl:if test="out_data!='(null)'"> const Nerv36::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>* _ret_dat_,</xsl:if> double _elapsed)
{
    PyGILState_STATE state = PyGILState_Ensure();
    this->get_override("on_<xsl:value-of select="$method_name"/>_return")(_msg_num, _err,<xsl:if test="out_data!='(null)'"> boost::ref(_ret_dat_),</xsl:if> _elapsed);
    PyGILState_Release(state);
}
              </xsl:when>
              <xsl:when test="type='SIGNAL'">
void <xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_return(Nerv36::Msg_num _msg_num, Nerv36::Error _err, double _elapsed)
{
    PyGILState_STATE state = PyGILState_Ensure();
    this->get_override("on_<xsl:value-of select="$method_name"/>_return")(_msg_num, _err, _elapsed);
    PyGILState_Release(state);
}
              </xsl:when>
              <xsl:when test="type='EVENT'">
void <xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_link(Nerv36::Msg_num _msg_num, Nerv36::Error _err, double _elapsed)
{
    PyGILState_STATE state = PyGILState_Ensure();
    this->get_override("on_<xsl:value-of select="$method_name"/>_link")(_msg_num, _err, _elapsed);
    PyGILState_Release(state);
}

void <xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_unlink(Nerv36::Error _err)
{
    PyGILState_STATE state = PyGILState_Ensure();
    this->get_override("on_<xsl:value-of select="$method_name"/>_unlink")(_err);
    PyGILState_Release(state);
}
                <xsl:choose >
                  <xsl:when test="out_data='(null)'">
void <xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>( double _elapsed)
{
    PyGILState_STATE state = PyGILState_Ensure();
    this->get_override("on_<xsl:value-of select="$method_name"/>")(_elapsed);
    PyGILState_Release(state);
}
                  </xsl:when>
                  <xsl:otherwise>
void <xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>(const Nerv36::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>* _evt_dat_, double _elapsed)
{
    PyGILState_STATE state = PyGILState_Ensure();
    this->get_override("on_<xsl:value-of select="$method_name"/>")(boost::ref(_evt_dat_), _elapsed);
    PyGILState_Release(state);
}
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:when>


              <xsl:when test="type='COMMAND'">
void <xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_link(Nerv36::Msg_num _msg_num, Nerv36::Error _err, double _elapsed)
{
    PyGILState_STATE state = PyGILState_Ensure();
    this->get_override("on_<xsl:value-of select="$method_name"/>_link")(_msg_num, _err, _elapsed);
    PyGILState_Release(state);
}
void <xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_unlink(Nerv36::Error _err)
{
    PyGILState_STATE state = PyGILState_Ensure();
    this->get_override("on_<xsl:value-of select="$method_name"/>_unlink")(_err);
    PyGILState_Release(state);
}
              </xsl:when>


              <xsl:when test="type='INFORMATION'">
void <xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_link(Nerv36::Msg_num _msg_num, Nerv36::Error _err, double _elapsed)
{
    PyGILState_STATE state = PyGILState_Ensure();
    this->get_override("on_<xsl:value-of select="$method_name"/>_link")(_msg_num, _err, _elapsed);
    PyGILState_Release(state);
}
void <xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_unlink(Nerv36::Error _err)
{
    PyGILState_STATE state = PyGILState_Ensure();
    this->get_override("on_<xsl:value-of select="$method_name"/>_unlink")(_err);
    PyGILState_Release(state);
}
                <xsl:choose >
                  <xsl:when test="out_data='(null)'">
void <xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_sync( Nerv36::Sync_model _sync_model, double _elapsed, double _limit )
{
    PyGILState_STATE state = PyGILState_Ensure();
    this->get_override("on_<xsl:value-of select="$method_name"/>_sync")((::Nerv36::uInt8)_sync_model, _elapsed, _limit);
    PyGILState_Release(state);
}
                  </xsl:when>
                  <xsl:otherwise>
void <xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_sync( Nerv36::Sync_model _sync_model, double _elapsed, double _limit, const Nerv36::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>* _buffer_ )
{
    PyGILState_STATE state = PyGILState_Ensure();
    this->get_override("on_<xsl:value-of select="$method_name"/>_sync")((::Nerv36::uInt8)_sync_model, _elapsed, _limit, boost::ref( _buffer_));
    PyGILState_Release(state);
}
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:when>


              <xsl:when test="type='BROADCAST'">
                <xsl:choose >
                  <xsl:when test="out_data='(null)'">
void <xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>( ::Nerv36::Address _stub_addr, double _elapsed)
{
    PyGILState_STATE state = PyGILState_Ensure();
    this->get_override("on_<xsl:value-of select="$method_name"/>")(_stub_addr, _elapsed);
    PyGILState_Release(state);
}
                  </xsl:when>
                  <xsl:otherwise>
void <xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>( ::Nerv36::Address _stub_addr, const Nerv36::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>* _buf_, double _elapsed)
{
    PyGILState_STATE state = PyGILState_Ensure();
    this->get_override("on_<xsl:value-of select="$method_name"/>")(_stub_addr, boost::ref(_buf_), _elapsed);
    PyGILState_Release(state);
}
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:when>
            </xsl:choose>
          </xsl:for-each>
        </xsl:for-each>
      </xsl:for-each>
    </xsl:for-each>
  </xsl:for-each>
</xsl:template>

</xsl:stylesheet>
