<?xml version="1.0" encoding="utf-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:include href="../xsl_util.xsl"/>
<xsl:output method="text" encoding="utf-8" indent="yes"/><xsl:param name = "save_path" />
<xsl:param name = "xml_path" />
<!-- TODO : xalan 을 이용하는 배치파일을 만든다. 컴포넌트.xml + excute_xalan = 컴포넌트.bat = 헤더파일 + 소스파일 + cmake 파일 + 등등..... --><!-- xalan $xalan_out "c:\dev/ncgen.bat" $xalan_param save_path "'c:\dev'" "c:\dev\ai data.xml" "./xsl/excute_xalan.xsl" -->
<xsl:template match="/">
<xsl:variable name="component_name">
  <xsl:call-template name="replace">
    <xsl:with-param name="text" select="nerv_icde/component/name" />
    <xsl:with-param name="replace" select="' '" />
    <xsl:with-param name="by" select="'_'" />
  </xsl:call-template>
</xsl:variable>
<xsl:text/>#!/bin/bash -v
echo $0 $@

source /usr/local/share/Nerv/Nerv36/script_make/xalan_option

mkdir -p "<xsl:value-of select="$save_path"/>/py_nerv36/import/Nerv36"

cp -r "/usr/local/share/Nerv/Nerv36/XSL/Python/.script" "<xsl:value-of select="$save_path"/>/."
cp -r "/usr/local/share/Nerv/Nerv36/lib" "<xsl:value-of select="$save_path"/>/py_nerv36/import/Nerv36/."
cp -r "/usr/local/share/Nerv/Nerv36/XSL/Python/py_nerv36/.script" "<xsl:value-of select="$save_path"/>/py_nerv36/."
cp -r "/usr/local/share/Nerv/Nerv36/XSL/Python/py_nerv36/config" "<xsl:value-of select="$save_path"/>/py_nerv36/."
cp "/usr/local/share/Nerv/Nerv36/XSL/Python/py_nerv36/source_list" "<xsl:value-of select="$save_path"/>/py_nerv36/."
cp -r "/usr/local/share/Nerv/Nerv36/XSL/Python/py_nerv36/import/jsoncpp" "<xsl:value-of select="$save_path"/>/py_nerv36/import/."
cp -r "/usr/local/share/Nerv/Nerv36/XSL/Python/py_nerv36/import/Waregram" "<xsl:value-of select="$save_path"/>/py_nerv36/import/."


<xsl:for-each select="nerv_icde/datadomain/row">
mkdir -p "<xsl:value-of select="$save_path"/>/py_nerv36/import/Nerv36/include/Nerv36/Data<xsl:value-of select="path"/>"<xsl:text/>

xalan $xalan_out "<xsl:value-of select="$save_path"/>/py_nerv36/import/Nerv36/include/Nerv36/Data<xsl:value-of select="path"/>/<xsl:value-of select="name"/>.h" $xalan_param export_data_domain_path "'<xsl:value-of select="path"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/Python/py_nerv36/import/Nerv36/include/Nerv36/Data/data_domain_h.xsl"<xsl:text/>
xalan $xalan_out "<xsl:value-of select="$save_path"/>/py_nerv36/import/Nerv36/include/Nerv36/Data<xsl:value-of select="path"/>/<xsl:value-of select="name"/>_export.h" $xalan_param export_data_domain_path "'<xsl:value-of select="path"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/Python/py_nerv36/import/Nerv36/include/Nerv36/Data/data_domain_export_h.xsl"<xsl:text/>
  <xsl:variable name="path" select="path"/>
  <xsl:for-each select="data/row">
xalan $xalan_out "<xsl:value-of select="$save_path"/>/py_nerv36/import/Nerv36/include/Nerv36/Data<xsl:value-of select="$path"/>/<xsl:value-of select="name"/>.h" $xalan_param export_data_domain_path "'<xsl:value-of select="$path"/>'" $xalan_param export_data_name "'<xsl:value-of select="name"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/Python/py_nerv36/import/Nerv36/include/Nerv36/Data/data_domain_data_h.xsl"<xsl:text/>
  </xsl:for-each>
</xsl:for-each>


cp "/usr/local/share/Nerv/Nerv36/XSL/Python/py_nerv36/import/Nerv36/include/Nerv36/Data/sizeof.h" "<xsl:value-of select="$save_path"/>/py_nerv36/import/Nerv36/include/Nerv36/Data/."
cp "/usr/local/share/Nerv/Nerv36/XSL/Python/py_nerv36/import/Nerv36/include/Nerv36/Data/copy.hpp" "<xsl:value-of select="$save_path"/>/py_nerv36/import/Nerv36/include/Nerv36/Data/."

<xsl:for-each select="nerv_icde/methoddomain/row">
mkdir -p "<xsl:value-of select="$save_path"/>/py_nerv36/import/Nerv36/include/Nerv36/Method<xsl:value-of select="path"/>"
xalan $xalan_out "<xsl:value-of select="$save_path"/>/py_nerv36/import/Nerv36/include/Nerv36/Method<xsl:value-of select="path"/>/<xsl:value-of select="name"/>.h" $xalan_param export_method_domain_path "'<xsl:value-of select="path"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/Python/py_nerv36/import/Nerv36/include/Nerv36/Method/method_domain_h.xsl"
</xsl:for-each>

<xsl:for-each select="nerv_icde/component/proxy_list/row">
mkdir -p "<xsl:value-of select="$save_path"/>/py_nerv36/src/Nerv/Proxy/<xsl:value-of select="class_name"/>"
xalan $xalan_out "<xsl:value-of select="$save_path"/>/py_nerv36/src/Nerv/Proxy/<xsl:value-of select="class_name"/>/<xsl:value-of select="class_name"/>.h" $xalan_param export_proxy_class_id "'<xsl:value-of select="id"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/Python/py_nerv36/src/Nerv/Proxy/proxy_class_h.xsl"
xalan $xalan_out "<xsl:value-of select="$save_path"/>/py_nerv36/src/Nerv/Proxy/<xsl:value-of select="class_name"/>/<xsl:value-of select="class_name"/>.cpp" $xalan_param export_proxy_class_id "'<xsl:value-of select="id"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/Python/py_nerv36/src/Nerv/Proxy/proxy_class_cpp.xsl"
xalan $xalan_out "<xsl:value-of select="$save_path"/>/py_nerv36/src/Nerv/Proxy/<xsl:value-of select="class_name"/>/<xsl:value-of select="class_name"/>_export.h" $xalan_param export_proxy_class_id "'<xsl:value-of select="id"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/Python/py_nerv36/src/Nerv/Proxy/proxy_class_export_h.xsl"
</xsl:for-each>

<xsl:for-each select="nerv_icde/component/stub_list/row">
mkdir -p "<xsl:value-of select="$save_path"/>/py_nerv36/src/Nerv/Stub/<xsl:value-of select="class_name"/>"
xalan $xalan_out "<xsl:value-of select="$save_path"/>/py_nerv36/src/Nerv/Stub/<xsl:value-of select="class_name"/>/<xsl:value-of select="class_name"/>.h" $xalan_param export_stub_class_id "'<xsl:value-of select="id"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/Python/py_nerv36/src/Nerv/Stub/stub_class_h.xsl"
xalan $xalan_out "<xsl:value-of select="$save_path"/>/py_nerv36/src/Nerv/Stub/<xsl:value-of select="class_name"/>/<xsl:value-of select="class_name"/>.cpp" $xalan_param export_stub_class_id "'<xsl:value-of select="id"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/Python/py_nerv36/src/Nerv/Stub/stub_class_cpp.xsl"
xalan $xalan_out "<xsl:value-of select="$save_path"/>/py_nerv36/src/Nerv/Stub/<xsl:value-of select="class_name"/>/<xsl:value-of select="class_name"/>_export.h" $xalan_param export_stub_class_id "'<xsl:value-of select="id"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/Python/py_nerv36/src/Nerv/Stub/stub_class_export_h.xsl"
</xsl:for-each>

xalan $xalan_out "<xsl:value-of select="$save_path"/>/py_nerv36/src/py_nerv.cpp" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/Python/py_nerv36/src/py_nerv_cpp.xsl"

<!-- xalan $xalan_out "<xsl:value-of select="$save_path"/>/py_nerv36/build/CMakeLists.txt" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/Python/build/CMakeLists.xsl" -->
<!-- xalan $xalan_out "<xsl:value-of select="$save_path"/>/py_nerv36/build/cmake_clean" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/Python/build/cmake_clean_sh.xsl" -->

<xsl:for-each select="nerv_icde/component/proxy_list/row">
xalan $xalan_out "<xsl:value-of select="$save_path"/>/<xsl:value-of select="class_name"/>.py" $xalan_param export_proxy_class_id "'<xsl:value-of select="id"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/Python/class_proxy_py.xsl"
</xsl:for-each>

<xsl:for-each select="nerv_icde/component/stub_list/row">
xalan $xalan_out "<xsl:value-of select="$save_path"/>/<xsl:value-of select="class_name"/>.py" $xalan_param export_stub_class_id "'<xsl:value-of select="id"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/Python/class_stub_py.xsl"
</xsl:for-each>

xalan $xalan_out "<xsl:value-of select="$save_path"/>/Nerv_Component_<xsl:value-of select="$component_name"/>.py" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/Python/component_py.xsl"

xalan $xalan_out "<xsl:value-of select="$save_path"/>/py_nerv36_print_data.py" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/Python/py_nerv36_print_data_py.xsl"
xalan $xalan_out "<xsl:value-of select="$save_path"/>/py_nerv36_set_data.py" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/Python/py_nerv36_set_data_py.xsl"
xalan $xalan_out "<xsl:value-of select="$save_path"/>/py_nerv36_thread.py" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/Python/py_nerv36_thread_py.xsl"

</xsl:template>

</xsl:stylesheet>
