<?xml version="1.0" encoding="UTF-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="text" encoding="utf-8" indent="yes"/>



<xsl:template name ="template_command" >
  <xsl:variable name="in_data_domain_namespace">
    <xsl:call-template name="get_data_domain_namespace">
      <xsl:with-param name="data_domain_id" select="in_data_domain_id" />
    </xsl:call-template>
  </xsl:variable>
  <xsl:variable name="out_data_domain_namespace">
    <xsl:call-template name="get_data_domain_namespace">
      <xsl:with-param name="data_domain_id" select="out_data_domain_id" />
    </xsl:call-template>
  </xsl:variable>

// proxy
struct Proxy_method_<xsl:value-of select="name"/>_ {
    virtual void on_<xsl:value-of select="name"/>_unlink(Error _err) = 0;
    virtual void on_<xsl:value-of select="name"/>_link(Msg_num _msg_num, Error _err, double _elapsed) = 0; //{}
};

class Proxy_method_<xsl:value-of select="name"/> : public Proxy_command {
    Proxy_method_<xsl:value-of select="name"/>_* interface_;

    virtual void on_link(Msg_num _msg_num, Error _err, double _elapsed)
    {
        interface_-&gt;on_<xsl:value-of select="name"/>_link(_msg_num, _err, _elapsed);
    }

    virtual void on_unlink( Error _err)
    {
        interface_-&gt;on_<xsl:value-of select="name"/>_unlink(_err);
    }

public:
    Proxy_method_<xsl:value-of select="name"/>(
        const Proxy&amp; _proxy_,
        Proxy_method_<xsl:value-of select="name"/>_* _interface_)
        : Proxy(_proxy_)
        , Proxy_command(<xsl:value-of select="code"/>, _proxy_)
        , interface_(_interface_)
    {
    }

    ~Proxy_method_<xsl:value-of select="name"/>()
    {
    }


    Error link( double _limit, double* _elapsed_ = 0)
    {
        Promise* promise_;
        promise_ = Proxy_command::async_link(_limit);
        Error err = Proxy_command::await_link_return(promise_, _elapsed_);
        return err;
    }


  <xsl:if test="in_data!='(null)'">
    Nerv36::Data<xsl:value-of select="$in_data_domain_namespace"/>::<xsl:value-of select="in_data"/>* get()
    {
        Nerv36::Data<xsl:value-of select="$in_data_domain_namespace"/>::<xsl:value-of select="in_data"/>* ret;
        ret = (Nerv36::Data<xsl:value-of select="$in_data_domain_namespace"/>::<xsl:value-of select="in_data"/>*) Proxy_command::get(sizeof(Nerv36::Data<xsl:value-of select="$in_data_domain_namespace"/>::<xsl:value-of select="in_data"/>) );
        return ret;
    }

    Error post( Nerv36::Data<xsl:value-of select="$in_data_domain_namespace"/>::<xsl:value-of select="in_data"/>* _cmd_dat_ )
    {
        Error err;
        ::Nerv36::Pksize cmd_size = _cmd_dat_-&gt;fit_size();

        if( cmd_size &lt; sizeof(Nerv36::Data<xsl:value-of select="$in_data_domain_namespace"/>::<xsl:value-of select="in_data"/>) ) {
            err = NERV_ERR_UNUSED_DYNAMIC_BUFFER_;
        }
        else {
            err = Proxy_command::post( cmd_size);
        }
        return err;
    }

    Error write( const Nerv36::Data<xsl:value-of select="$in_data_domain_namespace"/>::<xsl:value-of select="in_data"/>* _cmd_dat_)
    {
        Error err;
        ::Nerv36::Pksize cmd_size = _cmd_dat_-&gt;fit_size();
        if( cmd_size &lt; sizeof(Nerv36::Data<xsl:value-of select="$in_data_domain_namespace"/>::<xsl:value-of select="in_data"/>) ) {
            err = NERV_ERR_UNUSED_DYNAMIC_BUFFER_;
        }
        else {
            err = Proxy_command::write(_cmd_dat_, cmd_size);
        }
        return err;
    }

    Error read( Nerv36::Data<xsl:value-of select="$in_data_domain_namespace"/>::<xsl:value-of select="in_data"/>* _cmd_dat_)
    {
        Error err;
        Nerv36::Pksize cmd_size = sizeof(Nerv36::Data<xsl:value-of select="$in_data_domain_namespace"/>::<xsl:value-of select="in_data"/>);
        err = Proxy_command::read(_cmd_dat_, &amp;cmd_size );
        return err;
    }
  </xsl:if>
  <xsl:if test="in_data='(null)'">
    Error write()
    {
        return Proxy_command::write(0, 0);
    }
  </xsl:if>
};

// stub
struct Stub_method_<xsl:value-of select="name"/>_ {

    virtual Error on_<xsl:value-of select="name"/>_link(
        Address        _proxy_addr,
        double      _elapsed,
        double      _limit ) = 0;

    virtual void on_<xsl:value-of select="name"/>_unlink(
        Address        _proxy_addr,
        Error       _err) = 0;

    virtual void on_<xsl:value-of select="name"/>_sync(
        Address        _proxy_addr,
        Sync_model  _sync_model,
        double      _elapsed,
        double      _limit<xsl:if test="in_data!='(null)'">,
        const Nerv36::Data<xsl:value-of select="$in_data_domain_namespace"/>::<xsl:value-of select="in_data"/>* _cmd_dat_ </xsl:if>) = 0;
};

class Stub_method_<xsl:value-of select="name"/> : public Stub_command {

    Stub_method_<xsl:value-of select="name"/>_* interface_;


    virtual Error on_link( Address _proxy_addr, double _elapsed, double _limit )
    {
        return interface_-&gt;on_<xsl:value-of select="name"/>_link( _proxy_addr, _elapsed, _limit );
    }

    virtual void on_unlink( Address _proxy_addr, Error _err)
    {
        interface_-&gt;on_<xsl:value-of select="name"/>_unlink(_proxy_addr, _err);
    }


    virtual void on_sync(   Address            _proxy_addr,
                            Sync_model      _sync_model,
                            double          _elapsed,
                            double          _limit,
                            const void*     _cmd_dat_,
                            Pksize          _size)
    {
        interface_-&gt;on_<xsl:value-of select="name"/>_sync(_proxy_addr, _sync_model, _elapsed, _limit <xsl:if test="in_data!='(null)'">, (const Nerv36::Data<xsl:value-of select="$in_data_domain_namespace"/>::<xsl:value-of select="in_data"/>*)_cmd_dat_</xsl:if>);
    }

public:
    Stub_method_<xsl:value-of select="name"/>(
        const Stub&amp; _stub_,
        Stub_method_<xsl:value-of select="name"/>_* _interface_)
        : Stub(_stub_)
        , Stub_command(<xsl:value-of select="code"/>, _stub_)
        , interface_(_interface_)
    {
    }

    ~Stub_method_<xsl:value-of select="name"/>()
    {
    }


  <xsl:if test="in_data!='(null)'">
    Error read(Address _proxy_addr, Nerv36::Data<xsl:value-of select="$in_data_domain_namespace"/>::<xsl:value-of select="in_data"/>* _cmd_dat_)
    {
        Error err;
        Nerv36::Pksize inf_size = sizeof(Nerv36::Data<xsl:value-of select="$in_data_domain_namespace"/>::<xsl:value-of select="in_data"/>);
        err = Stub_command::read(_proxy_addr, _cmd_dat_, &amp;inf_size );
        return err;
    }
  </xsl:if>
};
</xsl:template>



</xsl:stylesheet>
