<?xml version="1.0" encoding="UTF-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="text" encoding="utf-8" indent="yes"/>



<xsl:template name ="template_signal" >
  <xsl:variable name="in_data_domain_namespace">
    <xsl:call-template name="get_data_domain_namespace">
      <xsl:with-param name="data_domain_id" select="in_data_domain_id" />
    </xsl:call-template>
  </xsl:variable>
  <xsl:variable name="out_data_domain_namespace">
    <xsl:call-template name="get_data_domain_namespace">
      <xsl:with-param name="data_domain_id" select="out_data_domain_id" />
    </xsl:call-template>
  </xsl:variable>


// proxy
struct Proxy_method_<xsl:value-of select="name"/>_ {
    virtual void on_<xsl:value-of select="name"/>_return(Msg_num _msg_num,
                           Error   _err,
                           double _elapsed) = 0; // {}
};

class Proxy_method_<xsl:value-of select="name"/> : public Nerv36::Proxy_signal
{
    Proxy_method_<xsl:value-of select="name"/>_* interface_;

    virtual void on_return(Msg_num _msg_num, Error _err, double _elapsed)
    {
        interface_-&gt;on_<xsl:value-of select="name"/>_return(_msg_num, _err, _elapsed);
    }

public:

    Proxy_method_<xsl:value-of select="name"/>(
        const Proxy&amp; _proxy_,
        Proxy_method_<xsl:value-of select="name"/>_* _interface_)
        : Proxy(_proxy_)
        , Proxy_signal(<xsl:value-of select="code"/>, _proxy_)
        , interface_(_interface_)
    {
    }

    ~Proxy_method_<xsl:value-of select="name"/>()
    {
    }

    <xsl:if test="in_data!='(null)'">
    Nerv36::Error delegate_signal(Msg_num* _msg_num_, const ::Nerv36::Data<xsl:value-of select="$in_data_domain_namespace"/>::<xsl:value-of select="in_data"/>* _sig_data_, double _limit = 1.0)
    {
        Error err;
        ::Nerv36::Pksize sig_size = _sig_data_-&gt;fit_size();
        if( sig_size &lt; sizeof(Nerv36::Data<xsl:value-of select="$in_data_domain_namespace"/>::<xsl:value-of select="in_data"/>) ) {
            err = NERV_ERR_UNUSED_DYNAMIC_BUFFER_;
        }
        else {
            err = Proxy_signal::delegate_signal(_msg_num_, _sig_data_, sig_size, _limit);
        }
        return err;
    }

    Nerv36::Error signal(const ::Nerv36::Data<xsl:value-of select="$in_data_domain_namespace"/>::<xsl:value-of select="in_data"/>* _sig_data_, double _limit = 1.0, double* _elapsed_= 0)
    {
        Error err;
        ::Nerv36::Pksize sig_size = _sig_data_-&gt;fit_size();
        if( sig_size &lt; sizeof(Nerv36::Data<xsl:value-of select="$in_data_domain_namespace"/>::<xsl:value-of select="in_data"/>) ) {
            err = NERV_ERR_UNUSED_DYNAMIC_BUFFER_;
        }
        else {
            err = Proxy_signal::signal(_sig_data_, sig_size, _limit, _elapsed_);
        }
        return err;
    }

    Nerv36::Promise* async_signal(const ::Nerv36::Data<xsl:value-of select="$in_data_domain_namespace"/>::<xsl:value-of select="in_data"/>* _sig_data_, double _limit = 1.0)
    {
        Nerv36::Promise* promise_;
        ::Nerv36::Pksize sig_size = _sig_data_-&gt;fit_size();
        if( sig_size &lt; sizeof(Nerv36::Data<xsl:value-of select="$in_data_domain_namespace"/>::<xsl:value-of select="in_data"/>) ) {
            promise_ = 0;
        }
        else {
            promise_ = Proxy_signal::async_signal(_sig_data_, sig_size, _limit);
        }
        return promise_;
    }

    Nerv36::Error await_return(Nerv36::Promise* _promise_, double* _elapsed_= 0)
    {
        Error err;
        if( _promise_ ) {
            err = Proxy_signal::await_return(_promise_, _elapsed_);
        }
        else {
            err = NERV_ERR_UNUSED_DYNAMIC_BUFFER_;
        }
        return err;
    }

    </xsl:if>
    <xsl:if test="in_data='(null)'">
    Nerv36::Error delegate_signal(Msg_num* _msg_num_,  double _limit = 1.0)
    {
        Error err;
        err = Proxy_signal::delegate_signal(_msg_num_, 0, 0, _limit);
        return err;
    }

    Nerv36::Error signal(double _limit = 1.0, double* _elapsed_= 0)
    {
        Error err;
        err = Proxy_signal::signal(0, 0, _limit, _elapsed_);
        return err;
    }

    Nerv36::Promise* async_signal( double _limit = 1.0)
    {
        Promise* promise_ = Proxy_signal::async_signal(0, 0, _limit);
        return promise_;
    }

    //Nerv36::Error await_return(Nerv36::Promise* _promise_, double* _elapsed_= 0)
    //{
    //    Error err;
    //    err = Proxy_signal::await_return(_promise_, _elapsed_);
    //    return err;
    //}
    </xsl:if>

    //void cancel( Error _err)
    //{
    //    Proxy_signal::cancel(_err);
    //}
};

// stub
struct Stub_method_<xsl:value-of select="name"/>_ {
    virtual void on_<xsl:value-of select="name"/>( Address _proxy_addr, <xsl:if test="in_data!='(null)'">const ::Nerv36::Data<xsl:value-of select="$in_data_domain_namespace"/>::<xsl:value-of select="in_data"/>* _buf_,</xsl:if> double _elapsed) = 0;
    virtual void on_<xsl:value-of select="name"/>_cancel( Address _proxy_addr, Error _err) = 0;
};
class Stub_method_<xsl:value-of select="name"/> : public Stub_signal
{
    Stub_method_<xsl:value-of select="name"/>_* interface_;

    virtual void on_signal( Address _proxy_addr,
                            const void* _buf_,
                            Pksize    _buf_size,
                            double      _elapsed )
    {
        interface_-&gt;on_<xsl:value-of select="name"/>(_proxy_addr, <xsl:if test="in_data!='(null)'">(const ::Nerv36::Data<xsl:value-of select="$in_data_domain_namespace"/>::<xsl:value-of select="in_data"/>*)_buf_,</xsl:if> _elapsed);
    }

    virtual void on_signal_cancel( Address _proxy_addr, Error _err)
    {
        interface_-&gt;on_<xsl:value-of select="name"/>_cancel(_proxy_addr,_err);
    }

public:

    Stub_method_<xsl:value-of select="name"/>(
        const Stub&amp; _stub_,
        Stub_method_<xsl:value-of select="name"/>_* _interface_)
        : Stub(_stub_)
        , Stub_signal(<xsl:value-of select="code"/>, _stub_, 0)
        , interface_(_interface_)
    {
    }

    ~Stub_method_<xsl:value-of select="name"/>()
    {
    }
};
</xsl:template>




</xsl:stylesheet>
