<?xml version="1.0" encoding="utf-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:include href="../../../../xsl_util.xsl"/>
<xsl:output method="text" encoding="utf-8" indent="yes"/>
<xsl:template match="/">
<xsl:variable name="component_name">
  <xsl:call-template name="replace">
    <xsl:with-param name="text" select="nerv_icde/component/name" />
    <xsl:with-param name="replace" select="' '" />
    <xsl:with-param name="by" select="'_'" />
  </xsl:call-template>
</xsl:variable>
#!/bin/bash

    echo $0 $@

    RELATIVE_DIR=$(dirname "$0")
    cd "$RELATIVE_DIR"
    cd ..

    export B_CLEAN=""
    export B_BUILD=""

    if [ "$1" = "clean" ] || [ "$2" = "clean" ] || [ "$3" = "clean" ]  || [ "$4" = "clean" ]; then
        export B_CLEAN="clean"
    fi
    if [ "$1" = "build" ] || [ "$2" = "build" ] || [ "$3" = "build" ]  || [ "$4" = "build" ]; then
        export B_BUILD="build"
    fi

	if [ "$1" = "" ]; then
		echo "Usage: _b [clean] [build]"
		echo "    [clean] delete directory ./build "
		echo "    [build] build cmake to ./build "
		echo ""
	fi

# build script running in ./build
	if [ "$B_CLEAN" = "clean" ]; then
        rm -rf build
        rm -rf devel
        rm -rf src
        rm .catkin_workspace
	fi

	if [ "$B_BUILD" = "build" ]; then
        source /opt/ros/melodic/setup.bash
        mkdir -vp src
        cd src
        catkin_create_pkg <xsl:value-of select="$component_name"/> std_msgs sensor_msgs geographic_msgs geometry_msgs roscpp message_generation message_runtime
        cd ..
        cp .script/CMakeLists.txt ./src/<xsl:value-of select="$component_name"/>/.
        cp -vr data/msg ./src/<xsl:value-of select="$component_name"/>/.
        cp -vr data/srv ./src/<xsl:value-of select="$component_name"/>/.
        catkin_make
        . ./devel/setup.bash
    fi

</xsl:template>
</xsl:stylesheet>
