<?xml version="1.0" encoding="utf-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:include href="../../../xsl_util.xsl"/>
<xsl:output method="text" encoding="utf-8" indent="yes"/>
<xsl:param name = "save_path" />
<xsl:param name = "xml_path" />
<!-- TODO : xalan 을 이용하는 배치파일을 만든다. 컴포넌트.xml + excute_xalan = 컴포넌트.bat = 헤더파일 + 소스파일 + cmake 파일 + 등등..... --><!-- xalan $xalan_out "c:\dev/ncgen.bat" $xalan_param save_path "'c:\dev'" "c:\dev\ai data.xml" "./xsl/excute_xalan.xsl" -->
<xsl:template match="/">
<xsl:variable name="component_name">
  <xsl:call-template name="replace">
    <xsl:with-param name="text" select="nerv_icde/component/name" />
    <xsl:with-param name="replace" select="' '" />
    <xsl:with-param name="by" select="'_'" />
  </xsl:call-template>
</xsl:variable>
#pragma once

#include "null.h"

<xsl:for-each select="nerv_icde/datadomain/row">
  <xsl:variable name="underscore_path">
    <xsl:call-template name="replace">
      <xsl:with-param name="text" select="path" />
      <xsl:with-param name="replace" select="'/'" />
      <xsl:with-param name="by" select="'__'" />
    </xsl:call-template>
  </xsl:variable>
  <xsl:variable name="ROS" select="starts-with(path, '/ROS/')"/>
    <xsl:variable name="ROS_path">
      <xsl:call-template name="replace">
        <xsl:with-param name="text" select="name" />
        <xsl:with-param name="replace" select="'/ROS/'" />
        <xsl:with-param name="by" select="''" />
      </xsl:call-template>
    </xsl:variable>
  <xsl:for-each select="data/row">
    <xsl:if test="not($ROS) or name!='Data_type'">
#include "<xsl:value-of select="name"/>_roscopy.hh"<xsl:text/>
    </xsl:if>
    <xsl:if test="$ROS and name='Data_type'">
// #include "<xsl:value-of select="name"/>_roscopy.hh"<xsl:text/>
    </xsl:if>
  </xsl:for-each>
</xsl:for-each>

<xsl:for-each select="nerv_icde/methoddomain/row/method/row[type='CALL' or type='CALLBACK']">
  <xsl:variable name="underscore_path">
    <xsl:call-template name="replace">
      <xsl:with-param name="text" select="../../path" />
      <xsl:with-param name="replace" select="'/'" />
      <xsl:with-param name="by" select="'__'" />
    </xsl:call-template>
  </xsl:variable>
#include "<xsl:value-of select="name"/>.h"<xsl:text/>
</xsl:for-each>


</xsl:template>
</xsl:stylesheet>
