<?xml version="1.0" encoding="utf-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:include href="../xsl_util.xsl"/>
<xsl:output method="text" encoding="utf-8" indent="yes"/>
<xsl:param name = "save_path" />
<xsl:param name = "xml_path" />
<!-- TODO : xalan 을 이용하는 배치파일을 만든다. 컴포넌트.xml + excute_xalan = 컴포넌트.bat = 헤더파일 + 소스파일 + cmake 파일 + 등등..... --><!-- xalan $xalan_out "c:\dev/ncgen.bat" $xalan_param save_path "'c:\dev'" "c:\dev\ai data.xml" "./xsl/excute_xalan.xsl" -->
<xsl:template match="/">
<xsl:variable name="component_name">
  <xsl:call-template name="replace">
    <xsl:with-param name="text" select="nerv_icde/component/name" />
    <xsl:with-param name="replace" select="' '" />
    <xsl:with-param name="by" select="'_'" />
  </xsl:call-template>
</xsl:variable>
<xsl:text/>#!/bin/bash -v
echo $0 $@

source /usr/local/share/Nerv/Nerv36/script_make/xalan_option

mkdir -vp "<xsl:value-of select="$save_path"/>/import/<xsl:value-of select="$component_name"/>/.script"
mkdir -vp "<xsl:value-of select="$save_path"/>/import/<xsl:value-of select="$component_name"/>/data/msg"
mkdir -vp "<xsl:value-of select="$save_path"/>/import/<xsl:value-of select="$component_name"/>/data/srv"
mkdir -vp "<xsl:value-of select="$save_path"/>/import/<xsl:value-of select="$component_name"/>/data/action"

cp  -vf   "/usr/local/share/Nerv/Nerv36/XSL/ROS/import/ros_data/data/msg/null.msg" "<xsl:value-of select="$save_path"/>/import/<xsl:value-of select="$component_name"/>/data/msg/null.msg"

xalan $xalan_out "<xsl:value-of select="$save_path"/>/import/<xsl:value-of select="$component_name"/>/.script/_b" $xalan_param component_name "'<xsl:value-of select="$component_name"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/ROS/import/ros_data/.script/_b.xsl"<xsl:text/>
xalan $xalan_out "<xsl:value-of select="$save_path"/>/import/<xsl:value-of select="$component_name"/>/.script/CMakeLists.txt" $xalan_param component_name "'<xsl:value-of select="$component_name"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/ROS/import/ros_data/.script/CMakeLists.xsl"<xsl:text/>
xalan $xalan_out "<xsl:value-of select="$save_path"/>/import/<xsl:value-of select="$component_name"/>/ros_data.hh" $xalan_param component_name "'<xsl:value-of select="$component_name"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/ROS/import/ros_data/ros_data_hh.xsl"<xsl:text/>

mkdir -vp "<xsl:value-of select="$save_path"/>/export"
mkdir -vp "<xsl:value-of select="$save_path"/>/import/Nerv36"
mkdir -vp "<xsl:value-of select="$save_path"/>/src"
mkdir -vp "<xsl:value-of select="$save_path"/>/bin"

cp -vr /usr/local/share/Nerv/Nerv36/include "<xsl:value-of select="$save_path"/>/import/Nerv36/."
cp -vr "/usr/local/share/Nerv/Nerv36/XSL/ROS/.vscode" "<xsl:value-of select="$save_path"/>/."
cp -vr "/usr/local/share/Nerv/Nerv36/XSL/ROS/.script" "<xsl:value-of select="$save_path"/>/."
cp -vr "/usr/local/share/Nerv/Nerv36/XSL/ROS/config" "<xsl:value-of select="$save_path"/>/."
cp "/usr/local/share/Nerv/Nerv36/XSL/ROS/source_list" "<xsl:value-of select="$save_path"/>/."
cp    "/usr/local/share/Nerv/Nerv36/XSL/ROS/import/Nerv36/include/Nerv36/nerv_env.hh" "<xsl:value-of select="$save_path"/>/import/Nerv36/include/Nerv36/."

cp -vrf  /usr/local/share/Nerv/Nerv36/lib/* "<xsl:value-of select="$save_path"/>/bin/."
# cp -vr  /usr/local/share/Nerv/Nerv36/lib "<xsl:value-of select="$save_path"/>/bin/."
cp -vr  /usr/local/share/Nerv/Nerv36/lib "<xsl:value-of select="$save_path"/>/import/Nerv36/."

rm -v "<xsl:value-of select="$save_path"/>/config/Linux_common/option.xsl"
xalan $xalan_out "<xsl:value-of select="$save_path"/>/config/Linux_common/option" $xalan_param component_name "'<xsl:value-of select="$component_name"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/ROS/config/Linux_common/option.xsl"<xsl:text/>

rm -v "<xsl:value-of select="$save_path"/>/config/Linux_common/prework.xsl"
xalan $xalan_out "<xsl:value-of select="$save_path"/>/config/Linux_common/prework" $xalan_param component_name "'<xsl:value-of select="$component_name"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/ROS/config/Linux_common/prework.xsl"<xsl:text/>
rm -v "<xsl:value-of select="$save_path"/>/.vscode/launch_json.xsl"
xalan $xalan_out "<xsl:value-of select="$save_path"/>/.vscode/launch.json" $xalan_param component_name "'<xsl:value-of select="$component_name"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/ROS/.vscode/launch_json.xsl"<xsl:text/>

xalan $xalan_out "<xsl:value-of select="$save_path"/>/src/<xsl:value-of select="$component_name"/>_nerv_component.hh" $xalan_param component_name "'<xsl:value-of select="$component_name"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/ROS/src/nerv_component_hh.xsl"<xsl:text/>
xalan $xalan_out "<xsl:value-of select="$save_path"/>/src/<xsl:value-of select="$component_name"/>_nerv_component.cc" $xalan_param component_name "'<xsl:value-of select="$component_name"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/ROS/src/nerv_component_cc.xsl"<xsl:text/>
xalan $xalan_out "<xsl:value-of select="$save_path"/>/src/main.cc" $xalan_param component_name "'<xsl:value-of select="$component_name"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/ROS/src/main_cc.xsl"<xsl:text/>
<xsl:for-each select="nerv_icde/component/proxy_list/row">
mkdir -vp "<xsl:value-of select="$save_path"/>/src/Nerv_Proxy/<xsl:value-of select="class_name"/>"
xalan $xalan_out "<xsl:value-of select="$save_path"/>/src/Nerv_Proxy/<xsl:value-of select="class_name"/>/<xsl:value-of select="class_name"/>.h" $xalan_param export_proxy_class_id "'<xsl:value-of select="id"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/ROS/src/Nerv_Proxy/proxy_class_h.xsl"
xalan $xalan_out "<xsl:value-of select="$save_path"/>/src/Nerv_Proxy/<xsl:value-of select="class_name"/>/<xsl:value-of select="class_name"/>.cpp" $xalan_param export_proxy_class_id "'<xsl:value-of select="id"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/ROS/src/Nerv_Proxy/proxy_class_cpp.xsl"
</xsl:for-each>

<xsl:for-each select="nerv_icde/component/stub_list/row">
mkdir -vp "<xsl:value-of select="$save_path"/>/src/Nerv_Stub/<xsl:value-of select="class_name"/>"
xalan $xalan_out "<xsl:value-of select="$save_path"/>/src/Nerv_Stub/<xsl:value-of select="class_name"/>/<xsl:value-of select="class_name"/>.h" $xalan_param export_stub_class_id "'<xsl:value-of select="id"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/ROS/src/Nerv_Stub/stub_class_h.xsl"
xalan $xalan_out "<xsl:value-of select="$save_path"/>/src/Nerv_Stub/<xsl:value-of select="class_name"/>/<xsl:value-of select="class_name"/>.cpp" $xalan_param export_stub_class_id "'<xsl:value-of select="id"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/ROS/src/Nerv_Stub/stub_class_cpp.xsl"
</xsl:for-each>

<xsl:for-each select="nerv_icde/datadomain/row">
mkdir -vp "<xsl:value-of select="$save_path"/>/import/Nerv36/include/Nerv36/Data<xsl:value-of select="path"/>"<xsl:text/>
xalan $xalan_out "<xsl:value-of select="$save_path"/>/import/Nerv36/include/Nerv36/Data<xsl:value-of select="path"/>/<xsl:value-of select="name"/>.hh" $xalan_param export_data_domain_path "'<xsl:value-of select="path"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/ROS/import/Nerv36/include/Nerv36/Data/data_domain_hh.xsl"<xsl:text/>
  <xsl:variable name="path" select="path"/>
  <xsl:for-each select="data/row">
    <xsl:variable name="underscore_path">
      <xsl:call-template name="replace">
        <xsl:with-param name="text" select="$path" />
        <xsl:with-param name="replace" select="'/'" />
        <xsl:with-param name="by" select="'__'" />
      </xsl:call-template>
    </xsl:variable>
xalan $xalan_out "<xsl:value-of select="$save_path"/>/import/Nerv36/include/Nerv36/Data<xsl:value-of select="$path"/>/<xsl:value-of select="name"/>.hh" $xalan_param export_data_domain_path "'<xsl:value-of select="$path"/>'" $xalan_param export_data_name "'<xsl:value-of select="name"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/ROS/import/Nerv36/include/Nerv36/Data/data_domain_data_hh.xsl"<xsl:text/>
xalan $xalan_out "<xsl:value-of select="$save_path"/>/import/<xsl:value-of select="$component_name"/>/<xsl:value-of select="name"/>_roscopy.hh" $xalan_param export_data_domain_path "'<xsl:value-of select="$path"/>'" $xalan_param export_data_name "'<xsl:value-of select="name"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/ROS/import/ros_data/ros_copy_data_hh.xsl"<xsl:text/>
xalan $xalan_out "<xsl:value-of select="$save_path"/>/import/<xsl:value-of select="$component_name"/>/data/msg/<xsl:value-of select="name"/>.msg" $xalan_param export_data_domain_path "'<xsl:value-of select="$path"/>'" $xalan_param export_data_name "'<xsl:value-of select="name"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/ROS/import/ros_data/data/msg/data_msg.xsl"<xsl:text/>
  </xsl:for-each>
</xsl:for-each>

<xsl:for-each select="nerv_icde/methoddomain/row">
mkdir -vp "<xsl:value-of select="$save_path"/>/import/Nerv36/include/Nerv36/Method<xsl:value-of select="path"/>"
  <xsl:variable name="path" select="path"/>
  <xsl:for-each select="method/row">
xalan $xalan_out "<xsl:value-of select="$save_path"/>/import/Nerv36/include/Nerv36/Method<xsl:value-of select="$path"/>/<xsl:value-of select="name"/>.hh" $xalan_param export_method_domain_path "'<xsl:value-of select="$path"/>'" $xalan_param export_method_name "'<xsl:value-of select="name"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/ROS/import/Nerv36/include/Nerv36/Method/method_domain_method_hh.xsl"<xsl:text/>
    <xsl:variable name="underscore_path">
      <xsl:call-template name="replace">
        <xsl:with-param name="text" select="$path" />
        <xsl:with-param name="replace" select="'/'" />
        <xsl:with-param name="by" select="'__'" />
      </xsl:call-template>
    </xsl:variable>
    <xsl:if test="type = 'CALL' or type = 'CALLBACK'">
xalan $xalan_out "<xsl:value-of select="$save_path"/>/import/<xsl:value-of select="$component_name"/>/data/srv/<xsl:value-of select="name"/>.srv" $xalan_param export_method_domain_path "'<xsl:value-of select="$path"/>'" $xalan_param export_method_name "'<xsl:value-of select="name"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/ROS/import/ros_data/data/srv/data_srv.xsl"<xsl:text/>
    </xsl:if>
  </xsl:for-each>
xalan $xalan_out "<xsl:value-of select="$save_path"/>/import/Nerv36/include/Nerv36/Method<xsl:value-of select="path"/>/<xsl:value-of select="name"/>.hh" $xalan_param export_method_domain_path "'<xsl:value-of select="path"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/ROS/import/Nerv36/include/Nerv36/Method/method_domain_hh.xsl"<xsl:text/>
</xsl:for-each>

</xsl:template>
</xsl:stylesheet>
