#pragma once

#include "Proxy.hh"

namespace Nerv36 {

class NERV_SDK_DLL Proxy_call : public virtual Proxy {
    friend class _Proxy_call;

public:
    Proxy_call(Msg_code _code);
    Proxy_call(Msg_code _code, const Proxy& _proxy_object_);
    virtual ~Proxy_call();

    Error delegate_call(Msg_num*    _msg_num_,
                           const void* _call_data_,
                           Pksize      _call_size,
                           double      _limit = 1.0);

    const Promise_ async_call(const void* _call_data_,
                              Pksize      _call_size,
                              double      _limit = 1.0);
    Error       await_return(Promise_ _promise_,
                               void*    _return_data_,
                               Pksize*  _size_,
                               double*  _time_);
    void           cancel(Error _error);

private:
    virtual void on_return(Msg_num     _msg_num,
                           Error    _err,
                           const void* _ret_data_,
                           Pksize      _ret_size,
                           double      _elapsed);

private:
    _Proxy_call* _mp;
};

} // namespace Nerv36
