#pragma once

#include "Proxy.hh"

namespace Nerv36 {

class NERV_SDK_DLL Proxy_event : virtual public Proxy {
    friend class _Proxy_event;

public:
    Proxy_event(Msg_code _code);
    Proxy_event(Msg_code _code, const Proxy& _proxy_object_);
    virtual ~Proxy_event();

    bool is_linked();

    Error delegate_link(Msg_num* _msg_num_, double _limit);

    const Promise_ async_link(double _limit = 1.0);
    Error       await_link_return(Promise_ _promise_, double* _time_);
    void           unlink();

private:
    virtual void on_unlink(Error _err);
    virtual void on_event(const void* _event_data_,
                          Pksize      _event_size,
                          double      _elapsed);

    virtual void on_link(Msg_num _msg_num, Error _err, double _time_);

private:
    _Proxy_event* _mp;
};

} // namespace Nerv36
