#pragma once

#include "Proxy.hh"
#include <Nerv36/History.hh>

namespace Nerv36 {

class NERV_SDK_DLL Proxy_information : virtual public Proxy {
    friend class _Proxy_information;

public:
    Proxy_information(Msg_code _code);
    Proxy_information(Msg_code _code, const Proxy& _proxy_object_);
    virtual ~Proxy_information(void);

    bool is_linked();

    Error delegate_link(Msg_num* _msg_num_,
                           bool     _reliability = false,
                           double   _limit = 1.0);

    const Promise_ async_link(bool   _reliability = false,
                              double _limit = 1.0);
    Error       await_link_return(Promise_ _promise_, double* _time_);
    void           unlink();
    void           set_sync(bool _use_on_sync);
    Letter_case_   see_history(size_t _size);
    void           set_history_size(size_t _history_size);
    Error       read(void* _data_, Pksize* _size_);

private:
    virtual void on_unlink(Error _err);
    virtual void on_link(Msg_num _msg_num, Error _err, double _time_);
    virtual void on_sync(Sync_model  _sync_model,
                         double      _elapsed,
                         double      _limit,
                         const void* _buffer_,
                         Pksize      _size);

private:
    _Proxy_information* _mp;
};

} // namespace Nerv36
