#pragma once

#include "nerv_define.h"
#include "nerv_typedef.hh"
#include <Nerv36/nerv_error.hh>
#include <shared_mutex>

namespace Nerv36 {
struct Stub_ {
    virtual void on_connect(Address _proxy_addr) = 0;
    virtual void on_disconnect(Address _proxy_addr) = 0;
};
class NERV_SDK_DLL Stub {

    friend class Nerv_processor;
    friend class _Stub;

public:
    Stub();
    virtual ~Stub();
    Error start(const char* _name_, Port* _port_);
    Error start_for_python(const char* _name_, int _port_);
    Error stop();
    bool  is_started();
    Error get_address(Address* _stub_addr_);

protected:
    virtual void on_connect(Address _proxy_addr);
    virtual void on_disconnect(Address _proxy_addr);

protected:
    _Stub* _op;
};
} // namespace Nerv36
