#pragma once

#include "Stub.hh"
#include <Nerv36/nerv_error.hh>

namespace Nerv36 {
class NERV_SDK_DLL Stub_event : virtual public Stub {
    friend class _Stub_event;

public:
    Stub_event(Msg_code _code);
    Stub_event(Msg_code _code, const Stub& _stub_);
    virtual ~Stub_event();
    void     unlink_all_proxy();
    void     unlink(Address _proxy_addr);
    Error notify(const void* _buffer_, Pksize _size);
    Error notify();

private:
    virtual Error on_link(Address   _proxy_addr,
                             double _elapsed,
                             double _limit);
    virtual void     on_unlink(Address _proxy_addr, Error _err);

private:
    _Stub_event* _mp;
};
} // namespace Nerv36
