#pragma once

#include "Stub.hh"
#include <Nerv36/History.hh>

namespace Nerv36 {
class NERV_SDK_DLL Stub_information : virtual public Stub {
    friend class _Stub_information;

public:
    Stub_information(Msg_code _code);
    Stub_information(Msg_code _code, const Stub& _stub_);
    virtual ~Stub_information(void);
    void         set_sync_model(Sync_model _sync_model, double _interval);
    void         unlink(Address _proxy_addr);
    void         unlink_all_proxy();
    void*        get(Pksize _size);
    void         cancel();
    Error     post(Pksize _size);
    Error     write(const void* _data_, Pksize _size);
    Letter_case_ see_history(size_t _size);
    void         set_history_size(size_t _history_size);
    Error     read(void* _data_, Pksize* _size_);

private:
    virtual Error on_link(Address   _proxy_addr,
                             bool   _reliability,
                             double _elapsed,
                             double _limit);
    virtual void     on_unlink(Address _proxy_addr, Error _err);

private:
    _Stub_information* _mp;
};
} // namespace Nerv36
