#pragma once

#include "Stub.hh"
#include "nerv_error.hh"

namespace Nerv36 {
typedef Error on_signal_sync_t(Stub_signal* _signal_,
                                  Address         _proxy_addr,
                                  void* const  _buf_,
                                  Pksize       _buf_size,
                                  double       _elapsed,
                                  double       _limit);

class NERV_SDK_DLL Stub_signal : virtual public Stub {
    friend class _Stub_signal;

public:
    Stub_signal(Msg_code _code);
    Stub_signal(Msg_code          _code,
                const Stub&       _stub_,
                on_signal_sync_t* _on_signal_sync_);
    virtual ~Stub_signal(void);

private:
    virtual void on_signal(Address        _proxy_addr,
                           const void* _buf_,
                           Pksize      _buf_size,
                           double      _elapsed);
    virtual void on_signal_cancel(Address _proxy_addr, Error _error);

private:
    _Stub_signal* _mp;
};
} // namespace Nerv36
