#pragma once

#include "Stub.hh"

namespace Nerv36 {

class NERV_SDK_DLL Stub_signalback : virtual public Stub {
    friend class _Stub_signalback;

public:
    Stub_signalback(Msg_code _code);
    Stub_signalback(Msg_code _code, const Stub& _stub_);
    virtual ~Stub_signalback(void);

    Error delegate_signalback(Msg_num*    _msg_num_,
                              Address        _proxy_addr,
                              const void* _signalback_data_,
                              Pksize      _signalback_size,
                              double      _limit);

    const Promise_ async_signalback(Address        _proxy_addr,
                                    const void* _signalback_data_,
                                    Pksize      _call_size,
                                    double      _limit = 1.0);
    Error          await_return(Promise_ _ret_promise, double* _time_ = 0);
    Error          signalback(Address         _proxy_addr,
                              const void*  _signalback_data_,
                              Pksize const _signalback_size,
                              double       _limit = 1.0,
                              double*      _time_ = 0);
    void           cancel(Address _proxy_addr, Error _error);

private:
    virtual void on_return(Msg_num _msg_num,
                           Address    _proxy_addr,
                           Error   _err,
                           double  _elapsed);

private:
    _Stub_signalback* _mp;
};

} // namespace Nerv36
