#pragma once

#include "nerv_define.h"
#include "nerv_pre_define.hh"
#include <stddef.h>
#include <stdint.h>

namespace Nerv36 {

typedef char       Char8;  // size : 1
typedef wchar_t    Char16; // size : 1
typedef ::int8_t   Int8;   // size : 1
typedef ::int16_t  Int16;  // size : 2
typedef ::int32_t  Int32;  // size : 4
typedef ::int64_t  Int64;  // size : 8
typedef ::uint8_t  uInt8;  // size : 1
typedef ::uint16_t uInt16; // size : 2
typedef ::uint32_t uInt32; // size : 4
typedef ::uint64_t uInt64; // size : 8
typedef uint8_t    Enum8;
typedef uint16_t   Enum16;
typedef uint32_t   Enum32;
typedef uint64_t   Enum64;
typedef ::size_t   Size; /* 데이터 크기    */

#if defined _MSC_VER || defined __GNUC__
typedef float                   Float32;
typedef double                  Float64;
#endif

#if defined           _MSC_VER
typedef unsigned long IP; /* IP add_ress     */
#else
typedef uint32_t IP; /* IP add_ress     */
#endif

typedef uint16_t Msg_num;  /* 메시지 넘버    */
typedef uint16_t Msg_code; /* 메시지 코드    */
typedef uint16_t Port;     /* Domain add_ress */
typedef uint32_t Pksize;   /* 데이터 크기    */
typedef uint64_t Clock;
typedef Promise* Promise_;

struct Msg_num_ref {
    Nerv36::Msg_num ref;
};

struct Address {
    IP          ip;
    Port        port;
    const char* id;
    Address() : ip(0U), port(0U), id(0) {}
    Address(IP _ip, Port _port) : ip(_ip), port(_port), id(0) {}
    Address(IP _ip, Port _port, const char* _id)
        : ip(_ip), port(_port), id(_id)
    {
    }
    Address(const char* _id)
        : ip(0), port(0), id(_id)
    {
    }
};

inline bool operator<(Address _left, Address _right)
{
    return (_left.port < _right.port ||
            (_left.port == _right.port && _left.ip < _right.ip));
}

enum class Sync_model : uint8_t { on_post = 0x00U, on_timer = 0x01U };

/* 가변 필드용 제어 구조체 */
struct Variable_array_field_dctrl {
    Pksize dindex; // byte 단위의 저장 인덱스 위치
    Pksize dsize;  // byte 단위의 size 저장
};

} // namespace Nerv36
